/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.37.0-dev.20230305(f20e0c8d472bababab79108dff951ae09460c4ed)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Q=function(O){for(var n=[],E=0,D=O.length;E<D;E++)n[E]=X[O[E]];return n};const Ee=this,Re=typeof global=="object"?global:{};var se;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(se||(se={}));var se;(function(O){class n{constructor(a,y,N){this.type=a,this.detail=y,this.timestamp=N}}O.LoaderEvent=n;class E{constructor(a){this._events=[new n(1,"",a)]}record(a,y){this._events.push(new n(a,y,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=E;class D{record(a,y){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(se||(se={}));var se;(function(O){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let a;for(a in D)D.hasOwnProperty(a)&&i(a,D[a])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(a,y)=>{y&&typeof y=="object"?i[a]=n.recursiveClone(y):i[a]=y}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(se||(se={}));var se;(function(O){function n(i){if(i instanceof Error)return i;const a=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(a.stack=i.stack),a}O.ensureError=n;class E{static validateConfigurationOptions(a){function y(N){if(N.phase==="loading"){console.error('Loading "'+N.moduleId+'" failed'),console.error(N),console.error("Here are the modules that depend on it:"),console.error(N.neededBy);return}if(N.phase==="factory"){console.error('The factory function of "'+N.moduleId+'" has thrown an exception'),console.error(N),console.error("Here are the modules that depend on it:"),console.error(N.neededBy);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError>"u"&&(a.catchError=!1),typeof a.recordStats>"u"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=y),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(O.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags>"u"&&(a.preferScriptTags=!1),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){const N=n(new Error("INVALID cached data configuration, 'path' MUST be set"));N.phase="configuration",a.onError(N),a.nodeCachedData=void 0}return a}static mergeConfigurationOptions(a=null,y=null){let N=O.Utilities.recursiveClone(y||{});return O.Utilities.forEachProperty(a,(u,g)=>{u==="ignoreDuplicateModules"&&typeof N.ignoreDuplicateModules<"u"?N.ignoreDuplicateModules=N.ignoreDuplicateModules.concat(g):u==="paths"&&typeof N.paths<"u"?O.Utilities.forEachProperty(g,(S,e)=>N.paths[S]=e):u==="config"&&typeof N.config<"u"?O.Utilities.forEachProperty(g,(S,e)=>N.config[S]=e):N[u]=O.Utilities.recursiveClone(g)}),E.validateConfigurationOptions(N)}}O.ConfigurationOptionsUtil=E;class D{constructor(a,y){if(this._env=a,this.options=E.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let N=this.options.nodeRequire.main.filename,u=Math.max(N.lastIndexOf("/"),N.lastIndexOf("\\"));this.options.baseUrl=N.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(a,y)=>{Array.isArray(y)?this.sortedPathsRules.push({from:a,to:y}):this.sortedPathsRules.push({from:a,to:[y]})}),this.sortedPathsRules.sort((a,y)=>y.from.length-a.from.length)}cloneAndMerge(a){return new D(this._env,E.mergeConfigurationOptions(a,this.options))}getOptionsLiteral(){return this.options}_applyPaths(a){let y;for(let N=0,u=this.sortedPathsRules.length;N<u;N++)if(y=this.sortedPathsRules[N],O.Utilities.startsWith(a,y.from)){let g=[];for(let S=0,e=y.to.length;S<e;S++)g.push(y.to[S]+a.substr(y.from.length));return g}return[a]}_addUrlArgsToUrl(a){return O.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a}_addUrlArgsIfNecessaryToUrls(a){if(this.options.urlArgs)for(let y=0,N=a.length;y<N;y++)a[y]=this._addUrlArgsToUrl(a[y]);return a}moduleIdToPaths(a){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a))return this.isBuild()?["empty:"]:["node|"+a];let y=a,N;if(!O.Utilities.endsWith(y,".js")&&!O.Utilities.isAbsolutePath(y)){N=this._applyPaths(y);for(let u=0,g=N.length;u<g;u++)this.isBuild()&&N[u]==="empty:"||(O.Utilities.isAbsolutePath(N[u])||(N[u]=this.options.baseUrl+N[u]),!O.Utilities.endsWith(N[u],".js")&&!O.Utilities.containsQueryString(N[u])&&(N[u]=N[u]+".js"))}else!O.Utilities.endsWith(y,".js")&&!O.Utilities.containsQueryString(y)&&(y=y+".js"),N=[y];return this._addUrlArgsIfNecessaryToUrls(N)}requireToUrl(a){let y=a;return O.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],O.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)}isBuild(){return this.options.isBuild}shouldInvokeFactory(a){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(a)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[a])}isDuplicateMessageIgnoredFor(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)}getConfigForModule(a){if(this.options.config)return this.options.config[a]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(a){this.options.onError(a)}}O.Configuration=D})(se||(se={}));var se;(function(O){class n{constructor(g){this._env=g,this._scriptLoader=null,this._callbackMap={}}load(g,S,e,w){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:C}=g.getConfig().getOptionsLiteral();C?this._scriptLoader=new E:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new E;let h={callback:e,errorback:w};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(h);return}this._callbackMap[S]=[h],this._scriptLoader.load(g,S,()=>this.triggerCallback(S),C=>this.triggerErrorback(S,C))}triggerCallback(g){let S=this._callbackMap[g];delete this._callbackMap[g];for(let e=0;e<S.length;e++)S[e].callback()}triggerErrorback(g,S){let e=this._callbackMap[g];delete this._callbackMap[g];for(let w=0;w<e.length;w++)e[w].errorback(S)}}class E{attachListeners(g,S,e){let w=()=>{g.removeEventListener("load",h),g.removeEventListener("error",C)},h=v=>{w(),S()},C=v=>{w(),e(v)};g.addEventListener("load",h),g.addEventListener("error",C)}load(g,S,e,w){if(/^node\|/.test(S)){let h=g.getConfig().getOptionsLiteral(),C=y(g.getRecorder(),h.nodeRequire||O.global.nodeRequire),v=S.split("|"),p=null;try{p=C(v[1])}catch(_){w(_);return}g.enqueueDefineAnonymousModule([],()=>p),e()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,e,w);const{trustedTypesPolicy:C}=g.getConfig().getOptionsLiteral();C&&(S=C.createScriptURL(S)),h.setAttribute("src",S);const{cspNonce:v}=g.getConfig().getOptionsLiteral();v&&h.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(h)}}}function D(u){const{trustedTypesPolicy:g}=u.getConfig().getOptionsLiteral();try{return(g?self.eval(g.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(g){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(g)),this._cachedCanUseEval}load(g,S,e,w){if(/^node\|/.test(S)){const h=g.getConfig().getOptionsLiteral(),C=y(g.getRecorder(),h.nodeRequire||O.global.nodeRequire),v=S.split("|");let p=null;try{p=C(v[1])}catch(_){w(_);return}g.enqueueDefineAnonymousModule([],function(){return p}),e()}else{const{trustedTypesPolicy:h}=g.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(g)){fetch(S).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${S}`,(h?self.eval(h.createScript("",v)):new Function(v)).call(self),e()}).then(void 0,w);return}try{h&&(S=h.createScriptURL(S)),importScripts(S),e()}catch(v){w(v)}}}}class a{constructor(g){this._env=g,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(g){this._didInitialize||(this._didInitialize=!0,this._fs=g("fs"),this._vm=g("vm"),this._path=g("path"),this._crypto=g("crypto"))}_initNodeRequire(g,S){const{nodeCachedData:e}=S.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const w=this,h=g("module");function C(v){const p=v.constructor;let _=function(f){try{return v.require(f)}finally{}};return _.resolve=function(f,d){return p._resolveFilename(f,v,!1,d)},_.resolve.paths=function(f){return p._resolveLookupPaths(f,v)},_.main=process.mainModule,_.extensions=p._extensions,_.cache=p._cache,_}h.prototype._compile=function(v,p){const _=h.wrap(v.replace(/^#!.*/,"")),b=S.getRecorder(),f=w._getCachedDataPath(e,p),d={filename:p};let m;try{const A=w._fs.readFileSync(f);m=A.slice(0,16),d.cachedData=A.slice(16),b.record(60,f)}catch{b.record(61,f)}const s=new w._vm.Script(_,d),l=s.runInThisContext(d),r=w._path.dirname(p),o=C(this),c=[this.exports,o,this,p,r,process,Re,Buffer],L=l.apply(this.exports,c);return w._handleCachedData(s,_,f,!d.cachedData,S),w._verifyCachedData(s,_,f,m,S),L}}load(g,S,e,w){const h=g.getConfig().getOptionsLiteral(),C=y(g.getRecorder(),h.nodeRequire||O.global.nodeRequire),v=h.nodeInstrumenter||function(_){return _};this._init(C),this._initNodeRequire(C,g);let p=g.getRecorder();if(/^node\|/.test(S)){let _=S.split("|"),b=null;try{b=C(_[1])}catch(f){w(f);return}g.enqueueDefineAnonymousModule([],()=>b),e()}else{S=O.Utilities.fileUriToFilePath(this._env.isWindows,S);const _=this._path.normalize(S),b=this._getElectronRendererScriptPathOrUri(_),f=Boolean(h.nodeCachedData),d=f?this._getCachedDataPath(h.nodeCachedData,S):void 0;this._readSourceAndCachedData(_,d,p,(m,s,l,r)=>{if(m){w(m);return}let o;s.charCodeAt(0)===a._BOM?o=a._PREFIX+s.substring(1)+a._SUFFIX:o=a._PREFIX+s+a._SUFFIX,o=v(o,_);const c={filename:b,cachedData:l},L=this._createAndEvalScript(g,o,c,e,w);this._handleCachedData(L,o,d,f&&!l,g),this._verifyCachedData(L,o,d,r,g)})}}_createAndEvalScript(g,S,e,w,h){const C=g.getRecorder();C.record(31,e.filename);const v=new this._vm.Script(S,e),p=v.runInThisContext(e),_=g.getGlobalAMDDefineFunc();let b=!1;const f=function(){return b=!0,_.apply(null,arguments)};return f.amd=_.amd,p.call(O.global,g.getGlobalAMDRequireFunc(),f,e.filename,this._path.dirname(e.filename)),C.record(32,e.filename),b?w():h(new Error(`Didn't receive define call in ${e.filename}!`)),v}_getElectronRendererScriptPathOrUri(g){if(!this._env.isElectronRenderer)return g;let S=g.match(/^([a-z])\:(.*)/i);return S?`file:///${(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/")}`:`file://${g}`}_getCachedDataPath(g,S){const e=this._crypto.createHash("md5").update(S,"utf8").update(g.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(S).replace(/\.js$/,"");return this._path.join(g.path,`${w}-${e}.code`)}_handleCachedData(g,S,e,w,h){g.cachedDataRejected?this._fs.unlink(e,C=>{h.getRecorder().record(62,e),this._createAndWriteCachedData(g,S,e,h),C&&h.getConfig().onError(C)}):w&&this._createAndWriteCachedData(g,S,e,h)}_createAndWriteCachedData(g,S,e,w){let h=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),C=-1,v=0,p;const _=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(S,"utf8").digest());const b=g.createCachedData();if(!(b.length===0||b.length===C||v>=5)){if(b.length<C){_();return}C=b.length,this._fs.writeFile(e,Buffer.concat([p,b]),f=>{f&&w.getConfig().onError(f),w.getRecorder().record(63,e),_()})}},h*Math.pow(4,v++))};_()}_readSourceAndCachedData(g,S,e,w){if(!S)this._fs.readFile(g,{encoding:"utf8"},w);else{let h,C,v,p=2;const _=b=>{b?w(b):--p===0&&w(void 0,h,C,v)};this._fs.readFile(g,{encoding:"utf8"},(b,f)=>{h=f,_(b)}),this._fs.readFile(S,(b,f)=>{!b&&f&&f.length>0?(v=f.slice(0,16),C=f.slice(16),e.record(60,S)):e.record(61,S),_()})}}_verifyCachedData(g,S,e,w,h){!w||g.cachedDataRejected||setTimeout(()=>{const C=this._crypto.createHash("md5").update(S,"utf8").digest();w.equals(C)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,v=>{v&&h.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random())))}}a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`;function y(u,g){if(g.__$__isRecorded)return g;const S=function(w){u.record(33,w);try{return g(w)}finally{u.record(34,w)}};return S.__$__isRecorded=!0,S}O.ensureRecordedNodeRequire=y;function N(u){return new n(u)}O.createScriptLoader=N})(se||(se={}));var se;(function(O){class n{constructor(u){let g=u.lastIndexOf("/");g!==-1?this.fromModulePath=u.substr(0,g+1):this.fromModulePath=""}static _normalizeModuleId(u){let g=u,S;for(S=/\/\.\//;S.test(g);)g=g.replace(S,"/");for(g=g.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(g);)g=g.replace(S,"/");return g=g.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),g}resolveModule(u){let g=u;return O.Utilities.isAbsolutePath(g)||(O.Utilities.startsWith(g,"./")||O.Utilities.startsWith(g,"../"))&&(g=n._normalizeModuleId(this.fromModulePath+g)),g}}n.ROOT=new n(""),O.ModuleIdResolver=n;class E{constructor(u,g,S,e,w,h){this.id=u,this.strId=g,this.dependencies=S,this._callback=e,this._errorback=w,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,g){try{return{returnedValue:u.apply(O.global,g),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}}static _invokeFactory(u,g,S,e){return u.shouldInvokeFactory(g)?u.shouldCatchError()?this._safeInvokeFunction(S,e):{returnedValue:S.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(u,g,S,e){this._isComplete=!0;let w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let h=E._invokeFactory(g,this.strId,this._callback,S);w=h.producedError,u.record(22,this.strId),!w&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(w){let h=O.ensureError(w);h.phase="factory",h.moduleId=this.strId,h.neededBy=e(this.id),this.error=h,g.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}O.Module=E;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let g=this._strModuleIdToIntModuleId.get(u);return typeof g>"u"&&(g=this._nextId++,this._strModuleIdToIntModuleId.set(u,g),this._intModuleIdToStrModuleId[g]=u),g}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class i{constructor(u){this.id=u}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class a{constructor(u,g,S){this.id=u,this.pluginId=g,this.pluginParam=S}}O.PluginDependency=a;class y{constructor(u,g,S,e,w=0){this._env=u,this._scriptLoader=g,this._loaderAvailableTimestamp=w,this._defineFunc=S,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new y(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,g){let S=h=>h.replace(/\\/g,"/"),e=S(u),w=g.split(/\n/);for(let h=0;h<w.length;h++){let C=w[h].match(/(.*):(\d+):(\d+)\)?$/);if(C){let v=C[1],p=C[2],_=C[3],b=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr(b),v=S(v),v===e){let f={line:parseInt(p,10),col:parseInt(_,10)};return f.line===1&&(f.col-=53),f}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],g=0;for(let S=0,e=this._modules2.length;S<e;S++){let w=this._modules2[S];if(!w)continue;let h=this._buildInfoPath[w.id]||null,C=this._buildInfoDefineStack[w.id]||null,v=this._buildInfoDependencies[w.id];u[g++]={id:w.strId,path:h,defineLocation:h&&C?y._findRelevantLocationInStack(h,C):null,dependencies:v,shim:null,exports:w.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,g){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:u,callback:g}}defineModule(u,g,S,e,w,h=new n(u)){let C=this._moduleIdProvider.getModuleId(u);if(this._modules2[C]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let v=new E(C,u,this._normalizeDependencies(g,h),S,e,h);this._modules2[C]=v,this._config.isBuild()&&(this._buildInfoDefineStack[C]=w,this._buildInfoDependencies[C]=(v.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(v)}_normalizeDependency(u,g){if(u==="exports")return i.EXPORTS;if(u==="module")return i.MODULE;if(u==="require")return i.REQUIRE;let S=u.indexOf("!");if(S>=0){let e=g.resolveModule(u.substr(0,S)),w=g.resolveModule(u.substr(S+1)),h=this._moduleIdProvider.getModuleId(e+"!"+w),C=this._moduleIdProvider.getModuleId(e);return new a(h,C,w)}return new i(this._moduleIdProvider.getModuleId(g.resolveModule(u)))}_normalizeDependencies(u,g){let S=[],e=0;for(let w=0,h=u.length;w<h;w++)S[e++]=this._normalizeDependency(u[w],g);return S}_relativeRequire(u,g,S,e){if(typeof g=="string")return this.synchronousRequire(g,u);this.defineModule(O.Utilities.generateAnonymousModule(),g,S,e,null,u)}synchronousRequire(u,g=new n(u)){let S=this._normalizeDependency(u,g),e=this._modules2[S.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(u,g){let S=this._config.shouldRecordStats();g?this._config=new O.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!S&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let g=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),g.dependencies,g.callback,null,g.stack)}}_createLoadError(u,g){let S=this._moduleIdProvider.getStrModuleId(u),e=(this._inverseDependencies2[u]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const w=O.ensureError(g);return w.phase="loading",w.moduleId=S,w.neededBy=e,w}_onLoadError(u,g){const S=this._createLoadError(u,g);this._modules2[u]||(this._modules2[u]=new E(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let e=[];for(let C=0,v=this._moduleIdProvider.getMaxModuleId();C<v;C++)e[C]=!1;let w=!1,h=[];for(h.push(u),e[u]=!0;h.length>0;){let C=h.shift(),v=this._modules2[C];v&&(w=v.onDependencyError(S)||w);let p=this._inverseDependencies2[C];if(p)for(let _=0,b=p.length;_<b;_++){let f=p[_];e[f]||(h.push(f),e[f]=!0)}}w||this._config.onError(S)}_hasDependencyPath(u,g){let S=this._modules2[u];if(!S)return!1;let e=[];for(let h=0,C=this._moduleIdProvider.getMaxModuleId();h<C;h++)e[h]=!1;let w=[];for(w.push(S),e[u]=!0;w.length>0;){let C=w.shift().dependencies;if(C)for(let v=0,p=C.length;v<p;v++){let _=C[v];if(_.id===g)return!0;let b=this._modules2[_.id];b&&!e[_.id]&&(e[_.id]=!0,w.push(b))}}return!1}_findCyclePath(u,g,S){if(u===g||S===50)return[u];let e=this._modules2[u];if(!e)return null;let w=e.dependencies;if(w)for(let h=0,C=w.length;h<C;h++){let v=this._findCyclePath(w[h].id,g,S+1);if(v!==null)return v.push(u),v}return null}_createRequire(u){let g=(S,e,w)=>this._relativeRequire(u,S,e,w);return g.toUrl=S=>this._config.requireToUrl(u.resolveModule(S)),g.getStats=()=>this.getLoaderEvents(),g.hasDependencyCycle=()=>this._hasDependencyCycle,g.config=(S,e=!1)=>{this.configure(S,e)},g.__$__nodeRequire=O.global.nodeRequire,g}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let g=this._moduleIdProvider.getStrModuleId(u),S=this._config.moduleIdToPaths(g),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(g.indexOf("/")===-1||e.test(g))&&S.push("node|"+g);let w=-1,h=C=>{if(w++,w>=S.length)this._onLoadError(u,C);else{let v=S[w],p=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[u]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}p.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=v),p.record(11,v),this._onLoad(u)},_=>{p.record(12,v),h(_)})}};h(null)}_loadPluginDependency(u,g){if(this._modules2[g.id]||this._knownModules2[g.id])return;this._knownModules2[g.id]=!0;let S=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(g.id),[],e,null,null)};S.error=e=>{this._config.onError(this._createLoadError(g.id,e))},u.load(g.pluginParam,this._createRequire(n.ROOT),S,this._config.getOptionsLiteral())}_resolve(u){let g=u.dependencies;if(g)for(let S=0,e=g.length;S<e;S++){let w=g[S];if(w===i.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(w===i.MODULE){u.unresolvedDependenciesCount--;continue}if(w===i.REQUIRE){u.unresolvedDependenciesCount--;continue}let h=this._modules2[w.id];if(h&&h.isComplete()){if(h.error){u.onDependencyError(h.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(w.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(w.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let C=this._findCyclePath(w.id,u.id,0)||[];C.reverse(),C.push(w.id),console.warn(C.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[w.id]=this._inverseDependencies2[w.id]||[],this._inverseDependencies2[w.id].push(u.id),w instanceof a){let C=this._modules2[w.pluginId];if(C&&C.isComplete()){this._loadPluginDependency(C.exports,w);continue}let v=this._inversePluginDependencies2.get(w.pluginId);v||(v=[],this._inversePluginDependencies2.set(w.pluginId,v)),v.push(w),this._loadModule(w.pluginId);continue}this._loadModule(w.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let g=this.getRecorder();if(u.isComplete())return;let S=u.dependencies,e=[];if(S)for(let v=0,p=S.length;v<p;v++){let _=S[v];if(_===i.EXPORTS){e[v]=u.exports;continue}if(_===i.MODULE){e[v]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(_===i.REQUIRE){e[v]=this._createRequire(u.moduleIdResolver);continue}let b=this._modules2[_.id];if(b){e[v]=b.exports;continue}e[v]=null}const w=v=>(this._inverseDependencies2[v]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));u.complete(g,this._config,e,w);let h=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,h)for(let v=0,p=h.length;v<p;v++){let _=h[v],b=this._modules2[_];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let C=this._inversePluginDependencies2.get(u.id);if(C){this._inversePluginDependencies2.delete(u.id);for(let v=0,p=C.length;v<p;v++)this._loadPluginDependency(u.exports,C[v])}}}O.ModuleManager=y})(se||(se={}));var Y,se;(function(O){const n=new O.Environment;let E=null;const D=function(N,u,g){typeof N!="string"&&(g=u,u=N,N=null),(typeof u!="object"||!Array.isArray(u))&&(g=u,u=null),u||(u=["require","exports","module"]),N?E.defineModule(N,u,g,null,null):E.enqueueDefineAnonymousModule(u,g)};D.amd={jQuery:!0};const i=function(N,u=!1){E.configure(N,u)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=i,a.getConfig=function(){return E.getConfig().getOptionsLiteral()},a.reset=function(){E=E.reset()},a.getBuildInfo=function(){return E.getBuildInfo()},a.getStats=function(){return E.getLoaderEvents()},a.define=D;function y(){if(typeof O.global.require<"u"||typeof require<"u"){const N=O.global.require||require;if(typeof N=="function"&&typeof N.resolve=="function"){const u=O.ensureRecordedNodeRequire(E.getRecorder(),N);O.global.nodeRequire=u,a.nodeRequire=u,a.__$__nodeRequire=u}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=a:(n.isElectronRenderer||(O.global.define=D),O.global.require=a)}O.init=y,(typeof O.global.define!="function"||!O.global.define.amd)&&(E=new O.ModuleManager(n,O.createScriptLoader(n),D,a,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&a.config(O.global.require),Y=function(){return D.apply(null,arguments)},Y.amd=D.amd,typeof doNotInitLoader>"u"&&y())})(se||(se={}));var fe=this&&this.__awaiter||function(O,n,E,D){function i(a){return a instanceof E?a:new E(function(y){y(a)})}return new(E||(E=Promise))(function(a,y){function N(S){try{g(D.next(S))}catch(e){y(e)}}function u(S){try{g(D.throw(S))}catch(e){y(e)}}function g(S){S.done?a(S.value):i(S.value).then(N,u)}g((D=D.apply(O,n||[])).next())})};Y(X[23],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(C,v){let p;return v.length===0?p=C:p=C.replace(/\{(\d+)\}/g,(_,b)=>{const f=b[0],d=v[f];let m=_;return typeof d=="string"?m=d:(typeof d=="number"||typeof d=="boolean"||d===void 0||d===null)&&(m=String(d)),m}),E&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function a(C,v){let p=C[v];return p||(p=C["*"],p)?p:null}function y(C){return C.charAt(C.length-1)==="/"?C:C+"/"}function N(C,v,p){return fe(this,void 0,void 0,function*(){const _=y(C)+y(v)+"vscode/"+y(p),b=yield fetch(_);if(b.ok)return yield b.json();throw new Error(`${b.status} - ${b.statusText}`)})}function u(C){return function(v,p){const _=Array.prototype.slice.call(arguments,2);return i(C[v],_)}}function g(C,v,...p){return i(v,p)}n.localize=g;function S(C){}n.getConfiguredDefaultLocale=S;function e(C){E=C}n.setPseudoTranslation=e;function w(C,v){var p;return{localize:u(v[C]),getConfiguredDefaultLocale:(p=v.getConfiguredDefaultLocale)!==null&&p!==void 0?p:_=>{}}}n.create=w;function h(C,v,p,_){var b;const f=(b=_["vs/nls"])!==null&&b!==void 0?b:{};if(!C||C.length===0)return p({localize:g,getConfiguredDefaultLocale:()=>{var r;return(r=f.availableLanguages)===null||r===void 0?void 0:r["*"]}});const d=f.availableLanguages?a(f.availableLanguages,C):null,m=d===null||d===D;let s=".nls";m||(s=s+"."+d);const l=r=>{Array.isArray(r)?r.localize=u(r):r.localize=u(r[C]),r.getConfiguredDefaultLocale=()=>{var o;return(o=f.availableLanguages)===null||o===void 0?void 0:o["*"]},p(r)};typeof f.loadBundle=="function"?f.loadBundle(C,d,(r,o)=>{r?v([C+".nls"],l):l(o)}):f.translationServiceUrl&&!m?fe(this,void 0,void 0,function*(){var r;try{const o=yield N(f.translationServiceUrl,d,C);return l(o)}catch(o){if(!d.includes("-"))return console.error(o),v([C+".nls"],l);try{const c=d.split("-")[0],L=yield N(f.translationServiceUrl,c,C);return(r=f.availableLanguages)!==null&&r!==void 0||(f.availableLanguages={}),f.availableLanguages["*"]=c,l(L)}catch(c){return console.error(c),v([C+".nls"],l)}}}):v([C+s],l,r=>{if(s===".nls"){console.error("Failed trying to load default language strings",r);return}console.error(`Failed to load message bundle for language ${d}. Falling back to the default language:`,r),v([C+".nls"],l)})}n.load=h}),function(){var O,n;const E=globalThis.MonacoEnvironment,D=E&&E.baseUrl?E.baseUrl:"../../../",i=typeof((O=self.trustedTypes)===null||O===void 0?void 0:O.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,...w)=>{const h=w.slice(0,-1).join(","),C=w.pop().toString();return`(function anonymous(${h}) { ${C}
})`}}):void 0;function a(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function y(){return new Promise((e,w)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return e();const h=D+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&a()){fetch(h).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${h}`,(i?globalThis.eval(i.createScript("",v)):new Function(v)).call(globalThis),e()}).then(void 0,w);return}i?importScripts(i.createScriptURL(h)):importScripts(h),e()})}function N(){require.config({baseUrl:D,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function u(e){y().then(()=>{N(),require([e],function(w){setTimeout(function(){const h=w.create((C,v)=>{globalThis.postMessage(C,v)},null);for(globalThis.onmessage=C=>h.onmessage(C.data,C.ports);S.length>0;){const C=S.shift();h.onmessage(C.data,C.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let g=!0;const S=[];globalThis.onmessage=e=>{if(!g){S.push(e);return}g=!1,u(e.data)}}(),Y(X[24],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(k,U=0){return k[k.length-(1+U)]}n.tail=E;function D(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=D;function i(k,U,F=(V,t)=>V===t){if(k===U)return!0;if(!k||!U||k.length!==U.length)return!1;for(let V=0,t=k.length;V<t;V++)if(!F(k[V],U[V]))return!1;return!0}n.equals=i;function a(k,U){const F=k.length-1;U<F&&(k[U]=k[F]),k.pop()}n.removeFastWithoutKeepingOrder=a;function y(k,U,F){return N(k.length,V=>F(k[V],U))}n.binarySearch=y;function N(k,U){let F=0,V=k-1;for(;F<=V;){const t=(F+V)/2|0,ne=U(t);if(ne<0)F=t+1;else if(ne>0)V=t-1;else return t}return-(F+1)}n.binarySearch2=N;function u(k,U){let F=0,V=k.length;if(V===0)return 0;for(;F<V;){const t=Math.floor((F+V)/2);U(k[t])?V=t:F=t+1}return F}n.findFirstInSorted=u;function g(k,U,F){if(k=k|0,k>=U.length)throw new TypeError("invalid index");const V=U[Math.floor(U.length*Math.random())],t=[],ne=[],le=[];for(const de of U){const we=F(de,V);we<0?t.push(de):we>0?ne.push(de):le.push(de)}return k<t.length?g(k,t,F):k<t.length+le.length?le[0]:g(k-(t.length+le.length),ne,F)}n.quickSelect=g;function S(k,U){const F=[];let V;for(const t of k.slice(0).sort(U))!V||U(V[0],t)!==0?(V=[t],F.push(V)):V.push(t);return F}n.groupBy=S;function e(k){return k.filter(U=>!!U)}n.coalesce=e;function w(k){let U=0;for(let F=0;F<k.length;F++)k[F]&&(k[U]=k[F],U+=1);k.length=U}n.coalesceInPlace=w;function h(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=h;function C(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=C;function v(k,U=F=>F){const F=new Set;return k.filter(V=>{const t=U(V);return F.has(t)?!1:(F.add(t),!0)})}n.distinct=v;function p(k,U){const F=_(k,U);if(F!==-1)return k[F]}n.findLast=p;function _(k,U){for(let F=k.length-1;F>=0;F--){const V=k[F];if(U(V))return F}return-1}n.lastIndex=_;function b(k,U){return k.length>0?k[0]:U}n.firstOrDefault=b;function f(k,U){let F=typeof U=="number"?k:0;typeof U=="number"?F=k:(F=0,U=k);const V=[];if(F<=U)for(let t=F;t<U;t++)V.push(t);else for(let t=F;t>U;t--)V.push(t);return V}n.range=f;function d(k,U,F){const V=k.slice(0,U),t=k.slice(U);return V.concat(F,t)}n.arrayInsert=d;function m(k,U){const F=k.indexOf(U);F>-1&&(k.splice(F,1),k.unshift(U))}n.pushToStart=m;function s(k,U){const F=k.indexOf(U);F>-1&&(k.splice(F,1),k.push(U))}n.pushToEnd=s;function l(k,U){for(const F of U)k.push(F)}n.pushMany=l;function r(k){return Array.isArray(k)?k:[k]}n.asArray=r;function o(k,U,F){const V=L(k,U),t=k.length,ne=F.length;k.length=t+ne;for(let le=t-1;le>=V;le--)k[le+ne]=k[le];for(let le=0;le<ne;le++)k[le+V]=F[le]}n.insertInto=o;function c(k,U,F,V){const t=L(k,U),ne=k.splice(t,F);return o(k,t,V),ne}n.splice=c;function L(k,U){return U<0?Math.max(U+k.length,0):Math.min(U,k.length)}var A;(function(k){function U(t){return t<0}k.isLessThan=U;function F(t){return t>0}k.isGreaterThan=F;function V(t){return t===0}k.isNeitherLessOrGreaterThan=V,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(A=n.CompareResult||(n.CompareResult={}));function R(k,U){return(F,V)=>U(k(F),k(V))}n.compareBy=R;const M=(k,U)=>k-U;n.numberComparator=M;function T(k,U){if(k.length===0)return;let F=k[0];for(let V=1;V<k.length;V++){const t=k[V];U(t,F)>0&&(F=t)}return F}n.findMaxBy=T;function W(k,U){if(k.length===0)return;let F=k[0];for(let V=1;V<k.length;V++){const t=k[V];U(t,F)>=0&&(F=t)}return F}n.findLastMaxBy=W;function I(k,U){return T(k,(F,V)=>-U(F,V))}n.findMinBy=I;class q{constructor(U){this.f=U,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(U){let F=this.c;for(;F<this.f.length&&U(this.f[F]);)F++;const V=F===this.c?null:this.f.slice(this.c,F);return this.c=F,V}takeFromEndWhile(U){let F=this.d;for(;F>=0&&U(this.f[F]);)F--;const V=F===this.d?null:this.f.slice(F+1,this.d+1);return this.d=F,V}peek(){if(this.length!==0)return this.f[this.c]}dequeue(){const U=this.f[this.c];return this.c++,U}takeCount(U){const F=this.f.slice(this.c,this.c+U);return this.c+=U,F}}n.ArrayQueue=q;class H{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(F=>(U.push(F),!0)),U}filter(U){return new H(F=>this.iterate(V=>U(V)?F(V):!0))}map(U){return new H(F=>this.iterate(V=>F(U(V))))}findLast(U){let F;return this.iterate(V=>(U(V)&&(F=V),!0)),F}findLastMaxBy(U){let F,V=!0;return this.iterate(t=>((V||A.isGreaterThan(U(t,F)))&&(V=!1,F=t),!0)),F}}H.empty=new H(k=>{}),n.CallbackIterable=H}),Y(X[25],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(a){this.c=a,this.a=void 0,this.b=void 0}get(a){const y=JSON.stringify(a);return this.b!==y&&(this.b=y,this.a=this.c(a)),this.a}}n.LRUCachedFunction=E;class D{get cachedValues(){return this.a}constructor(a){this.b=a,this.a=new Map}get(a){if(this.a.has(a))return this.a.get(a);const y=this.b(a);return this.a.set(a,y),y}}n.CachedFunction=D}),Y(X[26],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,a,y,N){this.originalStart=i,this.originalLength=a,this.modifiedStart=y,this.modifiedLength=N}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),Y(X[8],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(p){setTimeout(()=>{throw p.stack?h.isErrorNoTelemetry(p)?new h(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}c(p){this.b.forEach(_=>{_(p)})}onUnexpectedError(p){this.a(p),this.c(p)}onUnexpectedExternalError(p){this.a(p)}}n.ErrorHandler=E,n.errorHandler=new E;function D(v){N(v)||n.errorHandler.onUnexpectedError(v)}n.onUnexpectedError=D;function i(v){N(v)||n.errorHandler.onUnexpectedExternalError(v)}n.onUnexpectedExternalError=i;function a(v){if(v instanceof Error){const{name:p,message:_}=v,b=v.stacktrace||v.stack;return{$isError:!0,name:p,message:_,stack:b,noTelemetry:h.isErrorNoTelemetry(v)}}return v}n.transformErrorForSerialization=a;const y="Canceled";function N(v){return v instanceof u?!0:v instanceof Error&&v.name===y&&v.message===y}n.isCancellationError=N;class u extends Error{constructor(){super(y),this.name=this.message}}n.CancellationError=u;function g(){const v=new Error(y);return v.name=v.message,v}n.canceled=g;function S(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}n.illegalArgument=S;function e(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}n.illegalState=e;class w extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}n.NotSupportedError=w;class h extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof h)return p;const _=new h;return _.message=p.message,_.stack=p.stack,_}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class C extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}n.BugIndicatingError=C}),Y(X[9],Q([0,1,8]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(N,u){if(!N)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}n.ok=D;function i(N,u="Unreachable"){throw new Error(u)}n.assertNever=i;function a(N){if(!N()){debugger;N(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=a;function y(N,u){let g=0;for(;g<N.length-1;){const S=N[g],e=N[g+1];if(!u(S,e))return!1;g++}return!0}n.checkAdjacentItems=y}),Y(X[13],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(D){const i=this;let a=!1,y;return function(){return a||(a=!0,y=D.apply(i,arguments)),y}}n.once=E}),Y(X[14],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(D){function i(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}D.is=i;const a=Object.freeze([]);function y(){return a}D.empty=y;function*N(d){yield d}D.single=N;function u(d){return i(d)?d:N(d)}D.wrap=u;function g(d){return d||a}D.from=g;function S(d){return!d||d[Symbol.iterator]().next().done===!0}D.isEmpty=S;function e(d){return d[Symbol.iterator]().next().value}D.first=e;function w(d,m){for(const s of d)if(m(s))return!0;return!1}D.some=w;function h(d,m){for(const s of d)if(m(s))return s}D.find=h;function*C(d,m){for(const s of d)m(s)&&(yield s)}D.filter=C;function*v(d,m){let s=0;for(const l of d)yield m(l,s++)}D.map=v;function*p(...d){for(const m of d)for(const s of m)yield s}D.concat=p;function _(d,m,s){let l=s;for(const r of d)l=m(l,r);return l}D.reduce=_;function*b(d,m,s=d.length){for(m<0&&(m+=d.length),s<0?s+=d.length:s>d.length&&(s=d.length);m<s;m++)yield d[m]}D.slice=b;function f(d,m=Number.POSITIVE_INFINITY){const s=[];if(m===0)return[s,d];const l=d[Symbol.iterator]();for(let r=0;r<m;r++){const o=l.next();if(o.done)return[s,D.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return l}}]}D.consume=f})(E=n.Iterable||(n.Iterable={}))}),Y(X[27],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,h){this._keyCodeToStr[w]=h,this._strToKeyCode[h.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const D=new E,i=new E,a=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const y=[],N=Object.create(null),u=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],C=[];for(const v of w){const[p,_,b,f,d,m,s,l,r,o]=v;if(C[b]||(C[b]=!0,y[b]=f,N[f]=b,u[f.toLowerCase()]=b,_&&(n.IMMUTABLE_CODE_TO_KEY_CODE[b]=d,d!==0&&d!==3&&d!==5&&d!==4&&d!==6&&d!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[d]=b))),!h[d]){if(h[d]=!0,!m)throw new Error(`String representation missing for key code ${d} around scan code ${f}`);D.define(d,m),i.define(d,r||m),a.define(d,o||r||m)}s&&(n.EVENT_KEY_CODE_MAP[s]=d),l&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=d)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var g;(function(e){function w(b){return D.keyCodeToStr(b)}e.toString=w;function h(b){return D.strToKeyCode(b)}e.fromString=h;function C(b){return i.keyCodeToStr(b)}e.toUserSettingsUS=C;function v(b){return a.keyCodeToStr(b)}e.toUserSettingsGeneral=v;function p(b){return i.strToKeyCode(b)||a.strToKeyCode(b)}e.fromUserSettings=p;function _(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(b)}e.toElectronAccelerator=_})(g=n.KeyCodeUtils||(n.KeyCodeUtils={}));function S(e,w){const h=(w&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=S}),Y(X[28],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.d=i,this.a=!1}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}n.Lazy=E}),Y(X[10],Q([0,1,13,14]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let a=null;function y(l){a=l}if(n.setDisposableTracker=y,i){const l="__is_disposable_tracked__";y(new class{trackDisposable(r){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[l]||console.log(o)},3e3)}setParent(r,o){if(r&&r!==_.None)try{r[l]=!0}catch{}}markAsDisposed(r){if(r&&r!==_.None)try{r[l]=!0}catch{}}markAsSingleton(r){}})}function N(l){return a?.trackDisposable(l),l}function u(l){a?.markAsDisposed(l)}function g(l,r){a?.setParent(l,r)}function S(l,r){if(!!a)for(const o of l)a.setParent(o,r)}function e(l){return a?.markAsSingleton(l),l}n.markAsSingleton=e;function w(l){return typeof l.dispose=="function"&&l.dispose.length===0}n.isDisposable=w;function h(l){if(D.Iterable.is(l)){const r=[];for(const o of l)if(o)try{o.dispose()}catch(c){r.push(c)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}n.dispose=h;function C(...l){const r=v(()=>h(l));return S(l,r),r}n.combinedDisposable=C;function v(l){const r=N({dispose:(0,E.once)(()=>{u(r),l()})});return r}n.toDisposable=v;class p{constructor(){this.a=new Set,this.b=!1,N(this)}dispose(){this.b||(u(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(this.a.size!==0)try{h(this.a)}finally{this.a.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return g(r,this),this.b?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(r),r}}p.DISABLE_DISPOSED_WARNING=!1,n.DisposableStore=p;class _{constructor(){this.f=new p,N(this),g(this.f,this)}dispose(){u(this),this.f.dispose()}q(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(r)}}_.None=Object.freeze({dispose(){}}),n.Disposable=_;class b{constructor(){this.b=!1,N(this)}get value(){return this.b?void 0:this.a}set value(r){var o;this.b||r===this.a||((o=this.a)===null||o===void 0||o.dispose(),r&&g(r,this),this.a=r)}clear(){this.value=void 0}dispose(){var r;this.b=!0,u(this),(r=this.a)===null||r===void 0||r.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&g(r,null),r}}n.MutableDisposable=b;class f{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}n.RefCountedDisposable=f;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(r){let o=r;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,u(this))},this}}n.SafeDisposable=d;class m{constructor(r){this.object=r}dispose(){}}n.ImmortalReference=m;class s{constructor(){this.a=new Map,this.b=!1,N(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}get(r){return this.a.get(r)}set(r,o,c=!1){var L;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),c||(L=this.a.get(r))===null||L===void 0||L.dispose(),this.a.set(r,o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}n.DisposableMap=s}),Y(X[15],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(a){this.element=a,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class D{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let a=this.a;for(;a!==E.Undefined;){const y=a.next;a.prev=E.Undefined,a.next=E.Undefined,a=y}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(a){return this.d(a,!1)}push(a){return this.d(a,!0)}d(a,y){const N=new E(a);if(this.a===E.Undefined)this.a=N,this.b=N;else if(y){const g=this.b;this.b=N,N.prev=g,g.next=N}else{const g=this.a;this.a=N,N.next=g,g.prev=N}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(N))}}shift(){if(this.a!==E.Undefined){const a=this.a.element;return this.e(this.a),a}}pop(){if(this.b!==E.Undefined){const a=this.b.element;return this.e(this.b),a}}e(a){if(a.prev!==E.Undefined&&a.next!==E.Undefined){const y=a.prev;y.next=a.next,a.next.prev=y}else a.prev===E.Undefined&&a.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):a.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):a.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let a=this.a;for(;a!==E.Undefined;)yield a.element,a=a.next}}n.LinkedList=D}),Y(X[4],Q([0,1,25,28]),function(O,n,E,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function a(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=a;const y=/{(\d+)}/g;function N(P,...B){return B.length===0?P:P.replace(y,function(x,z){const Z=parseInt(z,10);return isNaN(Z)||Z<0||Z>=B.length?x:B[Z]})}n.format=N;function u(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=u;function g(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=g;function S(P,B=" "){const x=e(P,B);return w(x,B)}n.trim=S;function e(P,B){if(!P||!B)return P;const x=B.length;if(x===0||P.length===0)return P;let z=0;for(;P.indexOf(B,z)===z;)z=z+x;return P.substring(z)}n.ltrim=e;function w(P,B){if(!P||!B)return P;const x=B.length,z=P.length;if(x===0||z===0)return P;let Z=z,ie=-1;for(;ie=P.lastIndexOf(B,Z-1),!(ie===-1||ie+x!==Z);){if(ie===0)return"";Z=ie}return P.substring(0,Z)}n.rtrim=w;function h(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function C(P){return P.replace(/\*/g,"")}n.stripWildcards=C;function v(P,B,x={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=g(P)),x.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let z="";return x.global&&(z+="g"),x.matchCase||(z+="i"),x.multiline&&(z+="m"),x.unicode&&(z+="u"),new RegExp(P,z)}n.createRegExp=v;function p(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=p;function _(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=_;function b(P){return P.split(/\r\n|\r|\n/)}n.splitLines=b;function f(P){for(let B=0,x=P.length;B<x;B++){const z=P.charCodeAt(B);if(z!==32&&z!==9)return B}return-1}n.firstNonWhitespaceIndex=f;function d(P,B=0,x=P.length){for(let z=B;z<x;z++){const Z=P.charCodeAt(z);if(Z!==32&&Z!==9)return P.substring(B,z)}return P.substring(B,x)}n.getLeadingWhitespace=d;function m(P,B=P.length-1){for(let x=B;x>=0;x--){const z=P.charCodeAt(x);if(z!==32&&z!==9)return x}return-1}n.lastNonWhitespaceIndex=m;function s(P,B){return P<B?-1:P>B?1:0}n.compare=s;function l(P,B,x=0,z=P.length,Z=0,ie=B.length){for(;x<z&&Z<ie;x++,Z++){const ge=P.charCodeAt(x),re=B.charCodeAt(Z);if(ge<re)return-1;if(ge>re)return 1}const ue=z-x,Ce=ie-Z;return ue<Ce?-1:ue>Ce?1:0}n.compareSubstring=l;function r(P,B){return o(P,B,0,P.length,0,B.length)}n.compareIgnoreCase=r;function o(P,B,x=0,z=P.length,Z=0,ie=B.length){for(;x<z&&Z<ie;x++,Z++){let ge=P.charCodeAt(x),re=B.charCodeAt(Z);if(ge===re)continue;if(ge>=128||re>=128)return l(P.toLowerCase(),B.toLowerCase(),x,z,Z,ie);L(ge)&&(ge-=32),L(re)&&(re-=32);const he=ge-re;if(he!==0)return he}const ue=z-x,Ce=ie-Z;return ue<Ce?-1:ue>Ce?1:0}n.compareSubstringIgnoreCase=o;function c(P){return P>=48&&P<=57}n.isAsciiDigit=c;function L(P){return P>=97&&P<=122}n.isLowerAsciiLetter=L;function A(P){return P>=65&&P<=90}n.isUpperAsciiLetter=A;function R(P,B){return P.length===B.length&&o(P,B)===0}n.equalsIgnoreCase=R;function M(P,B){const x=B.length;return B.length>P.length?!1:o(P,B,0,x)===0}n.startsWithIgnoreCase=M;function T(P,B){const x=Math.min(P.length,B.length);let z;for(z=0;z<x;z++)if(P.charCodeAt(z)!==B.charCodeAt(z))return z;return x}n.commonPrefixLength=T;function W(P,B){const x=Math.min(P.length,B.length);let z;const Z=P.length-1,ie=B.length-1;for(z=0;z<x;z++)if(P.charCodeAt(Z-z)!==B.charCodeAt(ie-z))return z;return x}n.commonSuffixLength=W;function I(P){return 55296<=P&&P<=56319}n.isHighSurrogate=I;function q(P){return 56320<=P&&P<=57343}n.isLowSurrogate=q;function H(P,B){return(P-55296<<10)+(B-56320)+65536}n.computeCodePoint=H;function k(P,B,x){const z=P.charCodeAt(x);if(I(z)&&x+1<B){const Z=P.charCodeAt(x+1);if(q(Z))return H(z,Z)}return z}n.getNextCodePoint=k;function U(P,B){const x=P.charCodeAt(B-1);if(q(x)&&B>1){const z=P.charCodeAt(B-2);if(I(z))return H(z,x)}return x}class F{get offset(){return this.e}constructor(B,x=0){this.c=B,this.d=B.length,this.e=x}setOffset(B){this.e=B}prevCodePoint(){const B=U(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=k(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}n.CodePointIterator=F;class V{get offset(){return this.c.offset}constructor(B,x=0){this.c=new F(B,x)}nextGraphemeLength(){const B=ee.getInstance(),x=this.c,z=x.offset;let Z=B.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const ie=x.offset,ue=B.getGraphemeBreakType(x.nextCodePoint());if(K(Z,ue)){x.setOffset(ie);break}Z=ue}return x.offset-z}prevGraphemeLength(){const B=ee.getInstance(),x=this.c,z=x.offset;let Z=B.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const ie=x.offset,ue=B.getGraphemeBreakType(x.prevCodePoint());if(K(ue,Z)){x.setOffset(ie);break}Z=ue}return z-x.offset}eol(){return this.c.eol()}}n.GraphemeIterator=V;function t(P,B){return new V(P,B).nextGraphemeLength()}n.nextCharLength=t;function ne(P,B){return new V(P,B).prevGraphemeLength()}n.prevCharLength=ne;function le(P,B){B>0&&q(P.charCodeAt(B))&&B--;const x=B+t(P,B);return[x-ne(P,x),x]}n.getCharContainingOffset=le;let de;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(P){return de||(de=we()),de.test(P)}n.containsRTL=ye;const pe=/^[\t\n\r\x20-\x7E]*$/;function Se(P){return pe.test(P)}n.isBasicASCII=Se,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=Ne;function _e(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=_e;function J(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=J,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=j;function G(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=G;function $(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=$;function K(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}class ee{static getInstance(){return ee.c||(ee.c=new ee),ee.c}constructor(){this.d=te()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const x=this.d,z=x.length/3;let Z=1;for(;Z<=z;)if(B<x[3*Z])Z=2*Z;else if(B>x[3*Z+1])Z=2*Z+1;else return x[3*Z+2];return 0}}ee.c=null;function te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ae(P,B){if(P===0)return 0;const x=be(P,B);if(x!==void 0)return x;const z=new F(B,P);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=ae;function be(P,B){const x=new F(B,P);let z=x.prevCodePoint();for(;ve(z)||z===65039||z===8419;){if(x.offset===0)return;z=x.prevCodePoint()}if(!J(z))return;let Z=x.offset;return Z>0&&x.prevCodePoint()===8205&&(Z=x.offset),Z}function ve(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class oe{static getInstance(B){return oe.d.get(Array.from(B))}static getLocales(){return oe.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=oe,oe.c=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),oe.d=new E.LRUCachedFunction(P=>{function B(re){const he=new Map;for(let me=0;me<re.length;me+=2)he.set(re[me],re[me+1]);return he}function x(re,he){const me=new Map(re);for(const[Le,Ae]of he)me.set(Le,Ae);return me}function z(re,he){if(!re)return he;const me=new Map;for(const[Le,Ae]of re)he.has(Le)&&me.set(Le,Ae);return me}const Z=i.c.value;let ie=P.filter(re=>!re.startsWith("_")&&re in Z);ie.length===0&&(ie=["_default"]);let ue;for(const re of ie){const he=B(Z[re]);ue=z(ue,he)}const Ce=B(Z._common),ge=x(Ce,ue);return new oe(ge)}),oe.e=new D.Lazy(()=>Object.keys(oe.c.value).filter(P=>!P.startsWith("_"))),n.AmbiguousCharacters=oe;class ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ce.c())),this.d}static isInvisibleCharacter(B){return ce.e().has(B)}static get codePoints(){return ce.e()}}ce.d=void 0,n.InvisibleCharacters=ce}),Y(X[29],Q([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(v){return i(v,0)}n.hash=D;function i(v,p){switch(typeof v){case"object":return v===null?a(349,p):Array.isArray(v)?u(v,p):g(v,p);case"string":return N(v,p);case"boolean":return y(v,p);case"number":return a(v,p);case"undefined":return a(937,p);default:return a(617,p)}}n.doHash=i;function a(v,p){return(p<<5)-p+v|0}n.numberHash=a;function y(v,p){return a(v?433:863,p)}function N(v,p){p=a(149417,p);for(let _=0,b=v.length;_<b;_++)p=a(v.charCodeAt(_),p);return p}n.stringHash=N;function u(v,p){return p=a(104579,p),v.reduce((_,b)=>i(b,_),p)}function g(v,p){return p=a(181387,p),Object.keys(v).sort().reduce((_,b)=>(_=N(b,_),i(v[b],_)),p)}function S(v,p,_=32){const b=_-p,f=~((1<<b)-1);return(v<<p|(f&v)>>>b)>>>0}function e(v,p=0,_=v.byteLength,b=0){for(let f=0;f<_;f++)v[p+f]=b}function w(v,p,_="0"){for(;v.length<p;)v=_+v;return v}function h(v,p=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(_=>_.toString(16).padStart(2,"0")).join(""):w((v>>>0).toString(16),p/4)}n.toHexString=h;class C{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const _=p.length;if(_===0)return;const b=this.p;let f=this.r,d=this.u,m,s;for(d!==0?(m=d,s=-1,d=0):(m=p.charCodeAt(0),s=0);;){let l=m;if(E.isHighSurrogate(m))if(s+1<_){const r=p.charCodeAt(s+1);E.isLowSurrogate(r)?(s++,l=E.computeCodePoint(m,r)):l=65533}else{d=m;break}else E.isLowSurrogate(m)&&(l=65533);if(f=this.w(b,f,l),s++,s<_)m=p.charCodeAt(s);else break}this.r=f,this.u=d}w(p,_,b){return b<128?p[_++]=b:b<2048?(p[_++]=192|(b&1984)>>>6,p[_++]=128|(b&63)>>>0):b<65536?(p[_++]=224|(b&61440)>>>12,p[_++]=128|(b&4032)>>>6,p[_++]=128|(b&63)>>>0):(p[_++]=240|(b&1835008)>>>18,p[_++]=128|(b&258048)>>>12,p[_++]=128|(b&4032)>>>6,p[_++]=128|(b&63)>>>0),_>=64&&(this.y(),_-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),_}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,e(this.p,this.r),this.r>56&&(this.y(),e(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=C.g,_=this.q;for(let c=0;c<64;c+=4)p.setUint32(c,_.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,S(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let b=this.h,f=this.l,d=this.m,m=this.n,s=this.o,l,r,o;for(let c=0;c<80;c++)c<20?(l=f&d|~f&m,r=1518500249):c<40?(l=f^d^m,r=1859775393):c<60?(l=f&d|f&m|d&m,r=2400959708):(l=f^d^m,r=3395469782),o=S(b,5)+l+s+r+p.getUint32(c*4,!1)&4294967295,s=m,m=d,d=S(f,30),f=b,b=o;this.h=this.h+b&4294967295,this.l=this.l+f&4294967295,this.m=this.m+d&4294967295,this.n=this.n+m&4294967295,this.o=this.o+s&4294967295}}C.g=new DataView(new ArrayBuffer(320)),n.StringSHA1=C}),Y(X[16],Q([0,1,26,29]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.a=e}getElements(){const e=this.a,w=new Int32Array(e.length);for(let h=0,C=e.length;h<C;h++)w[h]=e.charCodeAt(h);return w}}n.StringDiffSequence=i;function a(S,e,w){return new g(new i(S),new i(e)).ComputeDiff(w).changes}n.stringDiff=a;class y{static Assert(e,w){if(!e)throw new Error(w)}}class N{static Copy(e,w,h,C,v){for(let p=0;p<v;p++)h[C+p]=e[w+p]}static Copy2(e,w,h,C,v){for(let p=0;p<v;p++)h[C+p]=e[w+p]}}class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(e,w){this.b=Math.min(this.b,e),this.c=Math.min(this.c,w),this.d++}AddModifiedElement(e,w){this.b=Math.min(this.b,e),this.c=Math.min(this.c,w),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(e,w,h=null){this.a=h,this.b=e,this.c=w;const[C,v,p]=g.o(e),[_,b,f]=g.o(w);this.d=p&&f,this.e=C,this.f=v,this.g=_,this.h=b,this.k=[],this.m=[]}static n(e){return e.length>0&&typeof e[0]=="string"}static o(e){const w=e.getElements();if(g.n(w)){const h=new Int32Array(w.length);for(let C=0,v=w.length;C<v;C++)h[C]=(0,D.stringHash)(w[C],0);return[w,h,!0]}return w instanceof Int32Array?[[],w,!1]:[[],new Int32Array(w),!1]}p(e,w){return this.f[e]!==this.h[w]?!1:this.d?this.e[e]===this.g[w]:!0}q(e,w){if(!this.p(e,w))return!1;const h=g.r(this.b,e),C=g.r(this.c,w);return h===C}static r(e,w){return typeof e.getStrictElement=="function"?e.getStrictElement(w):null}s(e,w){return this.f[e]!==this.f[w]?!1:this.d?this.e[e]===this.e[w]:!0}u(e,w){return this.h[e]!==this.h[w]?!1:this.d?this.g[e]===this.g[w]:!0}ComputeDiff(e){return this.v(0,this.f.length-1,0,this.h.length-1,e)}v(e,w,h,C,v){const p=[!1];let _=this.w(e,w,h,C,p);return v&&(_=this.z(_)),{quitEarly:p[0],changes:_}}w(e,w,h,C,v){for(v[0]=!1;e<=w&&h<=C&&this.p(e,h);)e++,h++;for(;w>=e&&C>=h&&this.p(w,C);)w--,C--;if(e>w||h>C){let m;return h<=C?(y.Assert(e===w+1,"originalStart should only be one more than originalEnd"),m=[new E.DiffChange(e,0,h,C-h+1)]):e<=w?(y.Assert(h===C+1,"modifiedStart should only be one more than modifiedEnd"),m=[new E.DiffChange(e,w-e+1,h,0)]):(y.Assert(e===w+1,"originalStart should only be one more than originalEnd"),y.Assert(h===C+1,"modifiedStart should only be one more than modifiedEnd"),m=[]),m}const p=[0],_=[0],b=this.y(e,w,h,C,p,_,v),f=p[0],d=_[0];if(b!==null)return b;if(!v[0]){const m=this.w(e,f,h,d,v);let s=[];return v[0]?s=[new E.DiffChange(f+1,w-(f+1)+1,d+1,C-(d+1)+1)]:s=this.w(f+1,w,d+1,C,v),this.H(m,s)}return[new E.DiffChange(e,w-e+1,h,C-h+1)]}x(e,w,h,C,v,p,_,b,f,d,m,s,l,r,o,c,L,A){let R=null,M=null,T=new u,W=w,I=h,q=l[0]-c[0]-C,H=-1073741824,k=this.k.length-1;do{const U=q+e;U===W||U<I&&f[U-1]<f[U+1]?(m=f[U+1],r=m-q-C,m<H&&T.MarkNextChange(),H=m,T.AddModifiedElement(m+1,r),q=U+1-e):(m=f[U-1]+1,r=m-q-C,m<H&&T.MarkNextChange(),H=m-1,T.AddOriginalElement(m,r+1),q=U-1-e),k>=0&&(f=this.k[k],e=f[0],W=1,I=f.length-1)}while(--k>=-1);if(R=T.getReverseChanges(),A[0]){let U=l[0]+1,F=c[0]+1;if(R!==null&&R.length>0){const V=R[R.length-1];U=Math.max(U,V.getOriginalEnd()),F=Math.max(F,V.getModifiedEnd())}M=[new E.DiffChange(U,s-U+1,F,o-F+1)]}else{T=new u,W=p,I=_,q=l[0]-c[0]-b,H=1073741824,k=L?this.m.length-1:this.m.length-2;do{const U=q+v;U===W||U<I&&d[U-1]>=d[U+1]?(m=d[U+1]-1,r=m-q-b,m>H&&T.MarkNextChange(),H=m+1,T.AddOriginalElement(m+1,r+1),q=U+1-v):(m=d[U-1],r=m-q-b,m>H&&T.MarkNextChange(),H=m,T.AddModifiedElement(m+1,r+1),q=U-1-v),k>=0&&(d=this.m[k],v=d[0],W=1,I=d.length-1)}while(--k>=-1);M=T.getChanges()}return this.H(R,M)}y(e,w,h,C,v,p,_){let b=0,f=0,d=0,m=0,s=0,l=0;e--,h--,v[0]=0,p[0]=0,this.k=[],this.m=[];const r=w-e+(C-h),o=r+1,c=new Int32Array(o),L=new Int32Array(o),A=C-h,R=w-e,M=e-h,T=w-C,I=(R-A)%2===0;c[A]=e,L[R]=w,_[0]=!1;for(let q=1;q<=r/2+1;q++){let H=0,k=0;d=this.J(A-q,q,A,o),m=this.J(A+q,q,A,o);for(let F=d;F<=m;F+=2){F===d||F<m&&c[F-1]<c[F+1]?b=c[F+1]:b=c[F-1]+1,f=b-(F-A)-M;const V=b;for(;b<w&&f<C&&this.p(b+1,f+1);)b++,f++;if(c[F]=b,b+f>H+k&&(H=b,k=f),!I&&Math.abs(F-R)<=q-1&&b>=L[F])return v[0]=b,p[0]=f,V<=L[F]&&1447>0&&q<=1447+1?this.x(A,d,m,M,R,s,l,T,c,L,b,w,v,f,C,p,I,_):null}const U=(H-e+(k-h)-q)/2;if(this.a!==null&&!this.a(H,U))return _[0]=!0,v[0]=H,p[0]=k,U>0&&1447>0&&q<=1447+1?this.x(A,d,m,M,R,s,l,T,c,L,b,w,v,f,C,p,I,_):(e++,h++,[new E.DiffChange(e,w-e+1,h,C-h+1)]);s=this.J(R-q,q,R,o),l=this.J(R+q,q,R,o);for(let F=s;F<=l;F+=2){F===s||F<l&&L[F-1]>=L[F+1]?b=L[F+1]-1:b=L[F-1],f=b-(F-R)-T;const V=b;for(;b>e&&f>h&&this.p(b,f);)b--,f--;if(L[F]=b,I&&Math.abs(F-A)<=q&&b<=c[F])return v[0]=b,p[0]=f,V>=c[F]&&1447>0&&q<=1447+1?this.x(A,d,m,M,R,s,l,T,c,L,b,w,v,f,C,p,I,_):null}if(q<=1447){let F=new Int32Array(m-d+2);F[0]=A-d+1,N.Copy2(c,d,F,1,m-d+1),this.k.push(F),F=new Int32Array(l-s+2),F[0]=R-s+1,N.Copy2(L,s,F,1,l-s+1),this.m.push(F)}}return this.x(A,d,m,M,R,s,l,T,c,L,b,w,v,f,C,p,I,_)}z(e){for(let w=0;w<e.length;w++){const h=e[w],C=w<e.length-1?e[w+1].originalStart:this.f.length,v=w<e.length-1?e[w+1].modifiedStart:this.h.length,p=h.originalLength>0,_=h.modifiedLength>0;for(;h.originalStart+h.originalLength<C&&h.modifiedStart+h.modifiedLength<v&&(!p||this.s(h.originalStart,h.originalStart+h.originalLength))&&(!_||this.u(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const f=this.q(h.originalStart,h.modifiedStart);if(this.q(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!f)break;h.originalStart++,h.modifiedStart++}const b=[null];if(w<e.length-1&&this.I(e[w],e[w+1],b)){e[w]=b[0],e.splice(w+1,1),w--;continue}}for(let w=e.length-1;w>=0;w--){const h=e[w];let C=0,v=0;if(w>0){const m=e[w-1];C=m.originalStart+m.originalLength,v=m.modifiedStart+m.modifiedLength}const p=h.originalLength>0,_=h.modifiedLength>0;let b=0,f=this.G(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let m=1;;m++){const s=h.originalStart-m,l=h.modifiedStart-m;if(s<C||l<v||p&&!this.s(s,s+h.originalLength)||_&&!this.u(l,l+h.modifiedLength))break;const o=(s===C&&l===v?5:0)+this.G(s,h.originalLength,l,h.modifiedLength);o>f&&(f=o,b=m)}h.originalStart-=b,h.modifiedStart-=b;const d=[null];if(w>0&&this.I(e[w-1],e[w],d)){e[w-1]=d[0],e.splice(w,1),w++;continue}}if(this.d)for(let w=1,h=e.length;w<h;w++){const C=e[w-1],v=e[w],p=v.originalStart-C.originalStart-C.originalLength,_=C.originalStart,b=v.originalStart+v.originalLength,f=b-_,d=C.modifiedStart,m=v.modifiedStart+v.modifiedLength,s=m-d;if(p<5&&f<20&&s<20){const l=this.A(_,f,d,s,p);if(l){const[r,o]=l;(r!==C.originalStart+C.originalLength||o!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=r-C.originalStart,C.modifiedLength=o-C.modifiedStart,v.originalStart=r+p,v.modifiedStart=o+p,v.originalLength=b-v.originalStart,v.modifiedLength=m-v.modifiedStart)}}}return e}A(e,w,h,C,v){if(w<v||C<v)return null;const p=e+w-v+1,_=h+C-v+1;let b=0,f=0,d=0;for(let m=e;m<p;m++)for(let s=h;s<_;s++){const l=this.B(m,s,v);l>0&&l>b&&(b=l,f=m,d=s)}return b>0?[f,d]:null}B(e,w,h){let C=0;for(let v=0;v<h;v++){if(!this.p(e+v,w+v))return 0;C+=this.e[e+v].length}return C}C(e){return e<=0||e>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[e])}D(e,w){if(this.C(e)||this.C(e-1))return!0;if(w>0){const h=e+w;if(this.C(h-1)||this.C(h))return!0}return!1}E(e){return e<=0||e>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[e])}F(e,w){if(this.E(e)||this.E(e-1))return!0;if(w>0){const h=e+w;if(this.E(h-1)||this.E(h))return!0}return!1}G(e,w,h,C){const v=this.D(e,w)?1:0,p=this.F(h,C)?1:0;return v+p}H(e,w){const h=[];if(e.length===0||w.length===0)return w.length>0?w:e;if(this.I(e[e.length-1],w[0],h)){const C=new Array(e.length+w.length-1);return N.Copy(e,0,C,0,e.length-1),C[e.length-1]=h[0],N.Copy(w,1,C,e.length,w.length-1),C}else{const C=new Array(e.length+w.length);return N.Copy(e,0,C,0,e.length),N.Copy(w,0,C,e.length,w.length),C}}I(e,w,h){if(y.Assert(e.originalStart<=w.originalStart,"Left change is not less than or equal to right change"),y.Assert(e.modifiedStart<=w.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=w.originalStart||e.modifiedStart+e.modifiedLength>=w.modifiedStart){const C=e.originalStart;let v=e.originalLength;const p=e.modifiedStart;let _=e.modifiedLength;return e.originalStart+e.originalLength>=w.originalStart&&(v=w.originalStart+w.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=w.modifiedStart&&(_=w.modifiedStart+w.modifiedLength-e.modifiedStart),h[0]=new E.DiffChange(C,v,p,_),!0}else return h[0]=null,!1}J(e,w,h,C){if(e>=0&&e<C)return e;const v=h,p=C-h-1,_=w%2===0;if(e<0){const b=v%2===0;return _===b?0:1}else{const b=p%2===0;return _===b?C-1:C-2}}}n.LcsDiff=g}),Y(X[17],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(_){return typeof _=="string"}n.isString=E;function D(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}n.isObject=D;function i(_){const b=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof b}n.isTypedArray=i;function a(_){return typeof _=="number"&&!isNaN(_)}n.isNumber=a;function y(_){return!!_&&typeof _[Symbol.iterator]=="function"}n.isIterable=y;function N(_){return _===!0||_===!1}n.isBoolean=N;function u(_){return typeof _>"u"}n.isUndefined=u;function g(_){return!S(_)}n.isDefined=g;function S(_){return u(_)||_===null}n.isUndefinedOrNull=S;function e(_,b){if(!_)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}n.assertType=e;function w(_){if(S(_))throw new Error("Assertion Failed: argument is undefined or null");return _}n.assertIsDefined=w;function h(_){return typeof _=="function"}n.isFunction=h;function C(_,b){const f=Math.min(_.length,b.length);for(let d=0;d<f;d++)v(_[d],b[d])}n.validateConstraints=C;function v(_,b){if(E(b)){if(typeof _!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(h(b)){try{if(_ instanceof b)return}catch{}if(!S(_)&&_.constructor===b||b.length===1&&b.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=v;function p(_){return _===null?void 0:_}n.withNullAsUndefined=p}),Y(X[30],Q([0,1,17]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(y,N){if((0,E.isString)(N)){const u=D[N];if(u===void 0)throw new Error(`${y} references an unknown codicon: ${N}`);N=u}return D[y]=N,{id:y}}function a(){return D}n.getCodiconFontCharacters=a,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[11],Q([0,1,17]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const C=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([v,p])=>{C[v]=p&&typeof p=="object"?D(p):p}),C}n.deepClone=D;function i(h){if(!h||typeof h!="object")return h;const C=[h];for(;C.length>0;){const v=C.shift();Object.freeze(v);for(const p in v)if(a.call(v,p)){const _=v[p];typeof _=="object"&&!Object.isFrozen(_)&&!(0,E.isTypedArray)(_)&&C.push(_)}}return h}n.deepFreeze=i;const a=Object.prototype.hasOwnProperty;function y(h,C){return N(h,C,new Set)}n.cloneAndChange=y;function N(h,C,v){if((0,E.isUndefinedOrNull)(h))return h;const p=C(h);if(typeof p<"u")return p;if(Array.isArray(h)){const _=[];for(const b of h)_.push(N(b,C,v));return _}if((0,E.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const _={};for(const b in h)a.call(h,b)&&(_[b]=N(h[b],C,v));return v.delete(h),_}return h}function u(h,C,v=!0){return(0,E.isObject)(h)?((0,E.isObject)(C)&&Object.keys(C).forEach(p=>{p in h?v&&((0,E.isObject)(h[p])&&(0,E.isObject)(C[p])?u(h[p],C[p],v):h[p]=C[p]):h[p]=C[p]}),h):C}n.mixin=u;function g(h,C){if(h===C)return!0;if(h==null||C===null||C===void 0||typeof h!=typeof C||typeof h!="object"||Array.isArray(h)!==Array.isArray(C))return!1;let v,p;if(Array.isArray(h)){if(h.length!==C.length)return!1;for(v=0;v<h.length;v++)if(!g(h[v],C[v]))return!1}else{const _=[];for(p in h)_.push(p);_.sort();const b=[];for(p in C)b.push(p);if(b.sort(),!g(_,b))return!1;for(v=0;v<_.length;v++)if(!g(h[_[v]],C[_[v]]))return!1}return!0}n.equals=g;function S(h){let C=[],v=Object.getPrototypeOf(h);for(;Object.prototype!==v;)C=C.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return C}n.getAllPropertyNames=S;function e(h){const C=[];for(const v of S(h))typeof h[v]=="function"&&C.push(v);return C}n.getAllMethodNames=e;function w(h,C){const v=_=>function(){const b=Array.prototype.slice.call(arguments,0);return C(_,b)},p={};for(const _ of h)p[_]=v(_);return p}n.createProxyObject=w}),Y(X[18],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),Y(X[19],Q([0,1,18]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(y){const N=(0,E.toUint8)(y);this.c=N,this.a=D.d(N),this.b=new Map}static d(y){const N=new Uint8Array(256);return N.fill(y),N}set(y,N){const u=(0,E.toUint8)(N);y>=0&&y<256?this.a[y]=u:this.b.set(y,u)}get(y){return y>=0&&y<256?this.a[y]:this.b.get(y)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}n.CharacterClassifier=D;class i{constructor(){this.a=new D(0)}add(y){this.a.set(y,1)}has(y){return this.a.get(y)===1}clear(){return this.a.clear()}}n.CharacterSet=i}),Y(X[3],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,a){this.lineNumber=i,this.column=a}with(i=this.lineNumber,a=this.column){return i===this.lineNumber&&a===this.column?this:new E(i,a)}delta(i=0,a=0){return this.with(this.lineNumber+i,this.column+a)}equals(i){return E.equals(this,i)}static equals(i,a){return!i&&!a?!0:!!i&&!!a&&i.lineNumber===a.lineNumber&&i.column===a.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<a.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<=a.column}static compare(i,a){const y=i.lineNumber|0,N=a.lineNumber|0;if(y===N){const u=i.column|0,g=a.column|0;return u-g}return y-N}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),Y(X[2],Q([0,1,3]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(a,y,N,u){a>N||a===N&&y>u?(this.startLineNumber=N,this.startColumn=u,this.endLineNumber=a,this.endColumn=y):(this.startLineNumber=a,this.startColumn=y,this.endLineNumber=N,this.endColumn=u)}isEmpty(){return D.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return D.containsPosition(this,a)}static containsPosition(a,y){return!(y.lineNumber<a.startLineNumber||y.lineNumber>a.endLineNumber||y.lineNumber===a.startLineNumber&&y.column<a.startColumn||y.lineNumber===a.endLineNumber&&y.column>a.endColumn)}static strictContainsPosition(a,y){return!(y.lineNumber<a.startLineNumber||y.lineNumber>a.endLineNumber||y.lineNumber===a.startLineNumber&&y.column<=a.startColumn||y.lineNumber===a.endLineNumber&&y.column>=a.endColumn)}containsRange(a){return D.containsRange(this,a)}static containsRange(a,y){return!(y.startLineNumber<a.startLineNumber||y.endLineNumber<a.startLineNumber||y.startLineNumber>a.endLineNumber||y.endLineNumber>a.endLineNumber||y.startLineNumber===a.startLineNumber&&y.startColumn<a.startColumn||y.endLineNumber===a.endLineNumber&&y.endColumn>a.endColumn)}strictContainsRange(a){return D.strictContainsRange(this,a)}static strictContainsRange(a,y){return!(y.startLineNumber<a.startLineNumber||y.endLineNumber<a.startLineNumber||y.startLineNumber>a.endLineNumber||y.endLineNumber>a.endLineNumber||y.startLineNumber===a.startLineNumber&&y.startColumn<=a.startColumn||y.endLineNumber===a.endLineNumber&&y.endColumn>=a.endColumn)}plusRange(a){return D.plusRange(this,a)}static plusRange(a,y){let N,u,g,S;return y.startLineNumber<a.startLineNumber?(N=y.startLineNumber,u=y.startColumn):y.startLineNumber===a.startLineNumber?(N=y.startLineNumber,u=Math.min(y.startColumn,a.startColumn)):(N=a.startLineNumber,u=a.startColumn),y.endLineNumber>a.endLineNumber?(g=y.endLineNumber,S=y.endColumn):y.endLineNumber===a.endLineNumber?(g=y.endLineNumber,S=Math.max(y.endColumn,a.endColumn)):(g=a.endLineNumber,S=a.endColumn),new D(N,u,g,S)}intersectRanges(a){return D.intersectRanges(this,a)}static intersectRanges(a,y){let N=a.startLineNumber,u=a.startColumn,g=a.endLineNumber,S=a.endColumn;const e=y.startLineNumber,w=y.startColumn,h=y.endLineNumber,C=y.endColumn;return N<e?(N=e,u=w):N===e&&(u=Math.max(u,w)),g>h?(g=h,S=C):g===h&&(S=Math.min(S,C)),N>g||N===g&&u>S?null:new D(N,u,g,S)}equalsRange(a){return D.equalsRange(this,a)}static equalsRange(a,y){return!a&&!y?!0:!!a&&!!y&&a.startLineNumber===y.startLineNumber&&a.startColumn===y.startColumn&&a.endLineNumber===y.endLineNumber&&a.endColumn===y.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(a){return new E.Position(a.endLineNumber,a.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(a){return new E.Position(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,y){return new D(this.startLineNumber,this.startColumn,a,y)}setStartPosition(a,y){return new D(a,y,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(a){return new D(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(a){return new D(a.endLineNumber,a.endColumn,a.endLineNumber,a.endColumn)}delta(a){return new D(this.startLineNumber+a,this.startColumn,this.endLineNumber+a,this.endColumn)}static fromPositions(a,y=a){return new D(a.lineNumber,a.column,y.lineNumber,y.column)}static lift(a){return a?new D(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,y){return!(a.endLineNumber<y.startLineNumber||a.endLineNumber===y.startLineNumber&&a.endColumn<y.startColumn||y.endLineNumber<a.startLineNumber||y.endLineNumber===a.startLineNumber&&y.endColumn<a.startColumn)}static areIntersecting(a,y){return!(a.endLineNumber<y.startLineNumber||a.endLineNumber===y.startLineNumber&&a.endColumn<=y.startColumn||y.endLineNumber<a.startLineNumber||y.endLineNumber===a.startLineNumber&&y.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,y){if(a&&y){const g=a.startLineNumber|0,S=y.startLineNumber|0;if(g===S){const e=a.startColumn|0,w=y.startColumn|0;if(e===w){const h=a.endLineNumber|0,C=y.endLineNumber|0;if(h===C){const v=a.endColumn|0,p=y.endColumn|0;return v-p}return h-C}return e-w}return g-S}return(a?1:0)-(y?1:0)}static compareRangesUsingEnds(a,y){return a.endLineNumber===y.endLineNumber?a.endColumn===y.endColumn?a.startLineNumber===y.startLineNumber?a.startColumn-y.startColumn:a.startLineNumber-y.startLineNumber:a.endColumn-y.endColumn:a.endLineNumber-y.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}n.Range=D}),Y(X[31],Q([0,1,3,2]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(y,N,u,g){super(y,N,u,g),this.selectionStartLineNumber=y,this.selectionStartColumn=N,this.positionLineNumber=u,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return i.selectionsEqual(this,y)}static selectionsEqual(y,N){return y.selectionStartLineNumber===N.selectionStartLineNumber&&y.selectionStartColumn===N.selectionStartColumn&&y.positionLineNumber===N.positionLineNumber&&y.positionColumn===N.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,N){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,y,N):new i(y,N,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(y,N){return this.getDirection()===0?new i(y,N,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,y,N)}static fromPositions(y,N=y){return new i(y.lineNumber,y.column,N.lineNumber,N.column)}static fromRange(y,N){return N===0?new i(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):new i(y.endLineNumber,y.endColumn,y.startLineNumber,y.startColumn)}static liftSelection(y){return new i(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,N){if(y&&!N||!y&&N)return!1;if(!y&&!N)return!0;if(y.length!==N.length)return!1;for(let u=0,g=y.length;u<g;u++)if(!this.selectionsEqual(y[u],N[u]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,N,u,g,S){return S===0?new i(y,N,u,g):new i(u,g,y,N)}}n.Selection=i}),Y(X[32],Q([0,1,19]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends E.CharacterClassifier{constructor(y){super(0);for(let N=0,u=y.length;N<u;N++)this.set(y.charCodeAt(N),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(a){const y={};return N=>(y.hasOwnProperty(N)||(y[N]=a(N)),y[N])}n.getMapForWordSeparators=i(a=>new D(a))}),Y(X[20],Q([0,1,14,15]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(g=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)g.indexOf(e)>=0||(S+="\\"+e);return S+="\\s]+)",new RegExp(S,"g")}n.DEFAULT_WORD_REGEXP=i();function a(g){let S=n.DEFAULT_WORD_REGEXP;if(g&&g instanceof RegExp)if(g.global)S=g;else{let e="g";g.ignoreCase&&(e+="i"),g.multiline&&(e+="m"),g.unicode&&(e+="u"),S=new RegExp(g.source,e)}return S.lastIndex=0,S}n.ensureValidWordDefinition=a;const y=new D.LinkedList;y.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function N(g,S,e,w,h){if(h||(h=E.Iterable.first(y)),e.length>h.maxLen){let b=g-h.maxLen/2;return b<0?b=0:w+=b,e=e.substring(b,g+h.maxLen/2),N(g,S,e,w,h)}const C=Date.now(),v=g-1-w;let p=-1,_=null;for(let b=1;!(Date.now()-C>=h.timeBudget);b++){const f=v-h.windowSize*b;S.lastIndex=Math.max(0,f);const d=u(S,e,v,p);if(!d&&_||(_=d,f<=0))break;p=f}if(_){const b={word:_[0],startColumn:w+1+_.index,endColumn:w+1+_.index+_[0].length};return S.lastIndex=0,b}return null}n.getWordAtText=N;function u(g,S,e,w){let h;for(;h=g.exec(S);){const C=h.index||0;if(C<=e&&g.lastIndex>=e)return h;if(w>0&&C>w)return null}return null}}),Y(X[5],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class E{constructor(a,y){this.seq1Range=a,this.seq2Range=y}reverse(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=E;class D{constructor(a,y){this.start=a,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(a){return new D(this.start+a,this.endExclusive+a)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(a){return new D(Math.min(this.start,a.start),Math.max(this.endExclusive,a.endExclusive))}}n.OffsetRange=D}),Y(X[33],Q([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function D(u,g,S){let e=S;return e=a(u,g,e),e=y(u,g,e),e}n.optimizeSequenceDiffs=D;function i(u,g,S){const e=[];for(const w of S){const h=e[e.length-1];if(!h){e.push(w);continue}w.seq1Range.start-h.seq1Range.endExclusive<=2||w.seq2Range.start-h.seq2Range.endExclusive<=2?e[e.length-1]=new E.SequenceDiff(h.seq1Range.join(w.seq1Range),h.seq2Range.join(w.seq2Range)):e.push(w)}return e}n.smoothenSequenceDiffs=i;function a(u,g,S){const e=[];S.length>0&&e.push(S[0]);for(let w=1;w<S.length;w++){const h=e[e.length-1],C=S[w];if(C.seq1Range.isEmpty){let v=!0;const p=C.seq1Range.start-h.seq1Range.endExclusive;for(let _=1;_<=p;_++)if(g.getElement(C.seq2Range.start-_)!==g.getElement(C.seq2Range.endExclusive-_)){v=!1;break}if(v){e[e.length-1]=new E.SequenceDiff(h.seq1Range,new E.OffsetRange(h.seq2Range.start,C.seq2Range.endExclusive-p));continue}}e.push(C)}return e}n.joinSequenceDiffs=a;function y(u,g,S){if(!u.getBoundaryScore||!g.getBoundaryScore)return S;for(let e=0;e<S.length;e++){const w=S[e];if(w.seq1Range.isEmpty){const h=e>0?S[e-1].seq2Range.endExclusive:-1,C=e+1<S.length?S[e+1].seq2Range.start:g.length;S[e]=N(w,u,g,C,h)}else if(w.seq2Range.isEmpty){const h=e>0?S[e-1].seq1Range.endExclusive:-1,C=e+1<S.length?S[e+1].seq1Range.start:u.length;S[e]=N(w.reverse(),g,u,C,h).reverse()}}return S}n.shiftSequenceDiffs=y;function N(u,g,S,e,w){let C=1;for(;u.seq2Range.start-C>w&&S.getElement(u.seq2Range.start-C)===S.getElement(u.seq2Range.endExclusive-C)&&C<20;)C++;C--;let v=0;for(;u.seq2Range.start+v<e&&S.getElement(u.seq2Range.start+v)===S.getElement(u.seq2Range.endExclusive+v)&&v<20;)v++;if(C===0&&v===0)return u;let p=0,_=-1;for(let b=-C;b<=v;b++){const f=u.seq2Range.start+b,d=u.seq2Range.endExclusive+b,m=u.seq1Range.start+b,s=g.getBoundaryScore(m)+S.getBoundaryScore(f)+S.getBoundaryScore(d);s>_&&(_=s,p=b)}return p!==0?new E.SequenceDiff(u.seq1Range.delta(p),u.seq2Range.delta(p)):u}}),Y(X[34],Q([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class D{compute(u,g){if(u.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,0),new E.OffsetRange(0,g.length))];if(g.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,u.length),new E.OffsetRange(0,0))];function S(f,d){for(;f<u.length&&d<g.length&&u.getElement(f)===g.getElement(d);)f++,d++;return f}let e=0;const w=new a;w.set(0,S(0,0));const h=new y;h.set(0,w.get(0)===0?null:new i(null,0,0,w.get(0)));let C=0;e:for(;;)for(e++,C=-e;C<=e;C+=2){const f=C===e?-1:w.get(C+1),d=C===-e?-1:w.get(C-1)+1,m=Math.min(Math.max(f,d),u.length),s=m-C,l=S(m,s);w.set(C,l);const r=m===f?h.get(C+1):h.get(C-1);if(h.set(C,l!==m?new i(r,m,s,l-m):r),w.get(C)===u.length&&w.get(C)-C===g.length)break e}let v=h.get(C);const p=[];let _=u.length,b=g.length;for(;;){const f=v?v.x+v.length:0,d=v?v.y+v.length:0;if((f!==_||d!==b)&&p.push(new E.SequenceDiff(new E.OffsetRange(f,_),new E.OffsetRange(d,b))),!v)break;_=v.x,b=v.y,v=v.prev}return p.reverse(),p}}n.MyersDiffAlgorithm=D;class i{constructor(u,g,S,e){this.prev=u,this.x=g,this.y=S,this.length=e}}class a{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){if(u<0){if(u=-u-1,u>=this.b.length){const S=this.b;this.b=new Int32Array(S.length*2),this.b.set(S)}this.b[u]=g}else{if(u>=this.a.length){const S=this.a;this.a=new Int32Array(S.length*2),this.a.set(S)}this.a[u]=g}}}class y{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,g){u<0?(u=-u-1,this.b[u]=g):this.a[u]=g}}}),Y(X[35],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,a){this.width=i,this.height=a,this.a=[],this.a=new Array(i*a)}get(i,a){return this.a[i+a*this.width]}set(i,a,y){this.a[i+a*this.width]=y}}n.Array2D=E}),Y(X[36],Q([0,1,5,35]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class i{compute(y,N,u){const g=new D.Array2D(y.length,N.length),S=new D.Array2D(y.length,N.length),e=new D.Array2D(y.length,N.length);for(let b=0;b<y.length;b++)for(let f=0;f<N.length;f++){const d=b===0?0:g.get(b-1,f),m=f===0?0:g.get(b,f-1);let s;y.getElement(b)===N.getElement(f)?(b===0||f===0?s=0:s=g.get(b-1,f-1),b>0&&f>0&&S.get(b-1,f-1)===3&&(s+=e.get(b-1,f-1)),s+=u?u(b,f):1):s=-1;const l=Math.max(d,m,s);if(l===s){const r=b>0&&f>0?e.get(b-1,f-1):0;e.set(b,f,r+1),S.set(b,f,3)}else l===d?(e.set(b,f,0),S.set(b,f,1)):l===m&&(e.set(b,f,0),S.set(b,f,2));g.set(b,f,l)}const w=[];let h=y.length,C=N.length;function v(b,f){(b+1!==h||f+1!==C)&&w.push(new E.SequenceDiff(new E.OffsetRange(b+1,h),new E.OffsetRange(f+1,C))),h=b,C=f}let p=y.length-1,_=N.length-1;for(;p>=0&&_>=0;)S.get(p,_)===3?(v(p,_),p--,_--):S.get(p,_)===1?p--:_--;return v(-1,-1),w.reverse(),w}}n.DynamicProgrammingDiffing=i}),Y(X[21],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class E{constructor(y,N,u){this.originalRange=y,this.modifiedRange=N,this.innerChanges=u}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=E;class D{constructor(y,N){this.originalRange=y,this.modifiedRange=N}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=D;class i{constructor(y,N){this.startLineNumber=y,this.endLineNumberExclusive=N}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(y){return new i(this.startLineNumber+y,this.endLineNumberExclusive+y)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(y){return new i(Math.min(this.startLineNumber,y.startLineNumber),Math.max(this.endLineNumberExclusive,y.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=i}),Y(X[37],Q([0,1,16,21,4,2,9]),function(O,n,E,D,i,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const N=3;class u{computeDiff(d,m,s){var l;const o=new v(d,m,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let L=null;for(const A of o.changes){let R;A.originalEndLineNumber===0?R=new D.LineRange(A.originalStartLineNumber+1,A.originalStartLineNumber+1):R=new D.LineRange(A.originalStartLineNumber,A.originalEndLineNumber+1);let M;A.modifiedEndLineNumber===0?M=new D.LineRange(A.modifiedStartLineNumber+1,A.modifiedStartLineNumber+1):M=new D.LineRange(A.modifiedStartLineNumber,A.modifiedEndLineNumber+1);let T=new D.LineRangeMapping(R,M,(l=A.charChanges)===null||l===void 0?void 0:l.map(W=>new D.RangeMapping(new a.Range(W.originalStartLineNumber,W.originalStartColumn,W.originalEndLineNumber,W.originalEndColumn),new a.Range(W.modifiedStartLineNumber,W.modifiedStartColumn,W.modifiedEndLineNumber,W.modifiedEndColumn))));L&&(L.modifiedRange.endLineNumberExclusive===T.modifiedRange.startLineNumber||L.originalRange.endLineNumberExclusive===T.originalRange.startLineNumber)&&(T=new D.LineRangeMapping(L.originalRange.join(T.originalRange),L.modifiedRange.join(T.modifiedRange),L.innerChanges&&T.innerChanges?L.innerChanges.concat(T.innerChanges):void 0),c.pop()),c.push(T),L=T}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(c,(A,R)=>R.originalRange.startLineNumber-A.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-A.modifiedRange.endLineNumberExclusive&&A.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&A.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),{quitEarly:o.quitEarly,changes:c}}}n.SmartLinesDiffComputer=u;function g(f,d,m,s){return new E.LcsDiff(f,d,m).ComputeDiff(s)}class S{constructor(d){const m=[],s=[];for(let l=0,r=d.length;l<r;l++)m[l]=p(d[l],1),s[l]=_(d[l],1);this.lines=d,this.a=m,this.b=s}getElements(){const d=[];for(let m=0,s=this.lines.length;m<s;m++)d[m]=this.lines[m].substring(this.a[m]-1,this.b[m]-1);return d}getStrictElement(d){return this.lines[d]}getStartLineNumber(d){return d+1}getEndLineNumber(d){return d+1}createCharSequence(d,m,s){const l=[],r=[],o=[];let c=0;for(let L=m;L<=s;L++){const A=this.lines[L],R=d?this.a[L]:1,M=d?this.b[L]:A.length+1;for(let T=R;T<M;T++)l[c]=A.charCodeAt(T-1),r[c]=L+1,o[c]=T,c++;!d&&L<s&&(l[c]=10,r[c]=L+1,o[c]=A.length+1,c++)}return new e(l,r,o)}}class e{constructor(d,m,s){this.a=d,this.b=m,this.d=s}toString(){return"["+this.a.map((d,m)=>(d===10?"\\n":String.fromCharCode(d))+`-(${this.b[m]},${this.d[m]})`).join(", ")+"]"}e(d,m){if(d<0||d>=m.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(d){return d>0&&d===this.b.length?this.getEndLineNumber(d-1):(this.e(d,this.b),this.b[d])}getEndLineNumber(d){return d===-1?this.getStartLineNumber(d+1):(this.e(d,this.b),this.a[d]===10?this.b[d]+1:this.b[d])}getStartColumn(d){return d>0&&d===this.d.length?this.getEndColumn(d-1):(this.e(d,this.d),this.d[d])}getEndColumn(d){return d===-1?this.getStartColumn(d+1):(this.e(d,this.d),this.a[d]===10?1:this.d[d]+1)}}class w{constructor(d,m,s,l,r,o,c,L){this.originalStartLineNumber=d,this.originalStartColumn=m,this.originalEndLineNumber=s,this.originalEndColumn=l,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=c,this.modifiedEndColumn=L}static createFromDiffChange(d,m,s){const l=m.getStartLineNumber(d.originalStart),r=m.getStartColumn(d.originalStart),o=m.getEndLineNumber(d.originalStart+d.originalLength-1),c=m.getEndColumn(d.originalStart+d.originalLength-1),L=s.getStartLineNumber(d.modifiedStart),A=s.getStartColumn(d.modifiedStart),R=s.getEndLineNumber(d.modifiedStart+d.modifiedLength-1),M=s.getEndColumn(d.modifiedStart+d.modifiedLength-1);return new w(l,r,o,c,L,A,R,M)}}function h(f){if(f.length<=1)return f;const d=[f[0]];let m=d[0];for(let s=1,l=f.length;s<l;s++){const r=f[s],o=r.originalStart-(m.originalStart+m.originalLength),c=r.modifiedStart-(m.modifiedStart+m.modifiedLength);Math.min(o,c)<N?(m.originalLength=r.originalStart+r.originalLength-m.originalStart,m.modifiedLength=r.modifiedStart+r.modifiedLength-m.modifiedStart):(d.push(r),m=r)}return d}class C{constructor(d,m,s,l,r){this.originalStartLineNumber=d,this.originalEndLineNumber=m,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=l,this.charChanges=r}static createFromDiffResult(d,m,s,l,r,o,c){let L,A,R,M,T;if(m.originalLength===0?(L=s.getStartLineNumber(m.originalStart)-1,A=0):(L=s.getStartLineNumber(m.originalStart),A=s.getEndLineNumber(m.originalStart+m.originalLength-1)),m.modifiedLength===0?(R=l.getStartLineNumber(m.modifiedStart)-1,M=0):(R=l.getStartLineNumber(m.modifiedStart),M=l.getEndLineNumber(m.modifiedStart+m.modifiedLength-1)),o&&m.originalLength>0&&m.originalLength<20&&m.modifiedLength>0&&m.modifiedLength<20&&r()){const W=s.createCharSequence(d,m.originalStart,m.originalStart+m.originalLength-1),I=l.createCharSequence(d,m.modifiedStart,m.modifiedStart+m.modifiedLength-1);if(W.getElements().length>0&&I.getElements().length>0){let q=g(W,I,r,!0).changes;c&&(q=h(q)),T=[];for(let H=0,k=q.length;H<k;H++)T.push(w.createFromDiffChange(q[H],W,I))}}return new C(L,A,R,M,T)}}class v{constructor(d,m,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=d,this.g=m,this.h=new S(d),this.j=new S(m),this.k=b(s.maxComputationTime),this.l=b(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const d=g(this.h,this.j,this.k,this.e),m=d.changes,s=d.quitEarly;if(this.d){const c=[];for(let L=0,A=m.length;L<A;L++)c.push(C.createFromDiffResult(this.d,m[L],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:c}}const l=[];let r=0,o=0;for(let c=-1,L=m.length;c<L;c++){const A=c+1<L?m[c+1]:null,R=A?A.originalStart:this.f.length,M=A?A.modifiedStart:this.g.length;for(;r<R&&o<M;){const T=this.f[r],W=this.g[o];if(T!==W){{let I=p(T,1),q=p(W,1);for(;I>1&&q>1;){const H=T.charCodeAt(I-2),k=W.charCodeAt(q-2);if(H!==k)break;I--,q--}(I>1||q>1)&&this.m(l,r+1,1,I,o+1,1,q)}{let I=_(T,1),q=_(W,1);const H=T.length+1,k=W.length+1;for(;I<H&&q<k;){const U=T.charCodeAt(I-1),F=T.charCodeAt(q-1);if(U!==F)break;I++,q++}(I<H||q<k)&&this.m(l,r+1,I,H,o+1,q,k)}}r++,o++}A&&(l.push(C.createFromDiffResult(this.d,A,this.h,this.j,this.l,this.a,this.b)),r+=A.originalLength,o+=A.modifiedLength)}return{quitEarly:s,changes:l}}m(d,m,s,l,r,o,c){if(this.n(d,m,s,l,r,o,c))return;let L;this.a&&(L=[new w(m,s,m,l,r,o,r,c)]),d.push(new C(m,m,r,r,L))}n(d,m,s,l,r,o,c){const L=d.length;if(L===0)return!1;const A=d[L-1];return A.originalEndLineNumber===0||A.modifiedEndLineNumber===0?!1:A.originalEndLineNumber===m&&A.modifiedEndLineNumber===r?(this.a&&A.charChanges&&A.charChanges.push(new w(m,s,m,l,r,o,r,c)),!0):A.originalEndLineNumber+1===m&&A.modifiedEndLineNumber+1===r?(A.originalEndLineNumber=m,A.modifiedEndLineNumber=r,this.a&&A.charChanges&&A.charChanges.push(new w(m,s,m,l,r,o,r,c)),!0):!1}}n.DiffComputer=v;function p(f,d){const m=i.firstNonWhitespaceIndex(f);return m===-1?d:m+1}function _(f,d){const m=i.lastNonWhitespaceIndex(f);return m===-1?d:m+2}function b(f){if(f===0)return()=>!0;const d=Date.now();return()=>Date.now()-d<f}}),Y(X[38],Q([0,1,9,3,2,5,36,33,34,21]),function(O,n,E,D,i,a,y,N,u,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class S{constructor(){this.b=new y.DynamicProgrammingDiffing,this.c=new u.MyersDiffAlgorithm}computeDiff(m,s,l){const r=new Map;function o(k){let U=r.get(k);return U===void 0&&(U=r.size,r.set(k,U)),U}const c=m.map(k=>o(k.trim())),L=s.map(k=>o(k.trim())),A=new h(c,m),R=new h(L,s);let M=(()=>A.length+R.length<1500?this.b.compute(A,R,(k,U)=>m[k]===s[U]?s[U].length===0?.1:1+Math.log(1+s[U].length):.99):this.c.compute(A,R))();M=(0,N.optimizeSequenceDiffs)(A,R,M);const T=[],W=k=>{for(let U=0;U<k;U++){const F=I+U,V=q+U;if(m[F]!==s[V]){const t=this.e(m,s,new a.SequenceDiff(new a.OffsetRange(F,F+1),new a.OffsetRange(V,V+1)));for(const ne of t)T.push(ne)}}};let I=0,q=0;for(const k of M){(0,E.assertFn)(()=>k.seq1Range.start-I===k.seq2Range.start-q);const U=k.seq1Range.start-I;W(U),I=k.seq1Range.endExclusive,q=k.seq2Range.endExclusive;const F=this.e(m,s,k);for(const V of F)T.push(V)}W(m.length-I);const H=e(T);return{quitEarly:!1,changes:H}}e(m,s,l){const r=new v(m,l.seq1Range),o=new v(s,l.seq2Range),c=r.length+o.length<500?this.b.compute(r,o):this.c.compute(r,o);let L=(0,N.optimizeSequenceDiffs)(r,o,c);return L=(0,N.smoothenSequenceDiffs)(r,o,L),L.map(R=>new g.RangeMapping(r.translateRange(R.seq1Range).delta(l.seq1Range.start),o.translateRange(R.seq2Range).delta(l.seq2Range.start)))}}n.StandardLinesDiffComputer=S;function e(d){const m=[];for(const s of w(d,(l,r)=>r.originalRange.startLineNumber-(l.originalRange.endLineNumber-(l.originalRange.endColumn>1?0:1))<=1||r.modifiedRange.startLineNumber-(l.modifiedRange.endLineNumber-(l.modifiedRange.endColumn>1?0:1))<=1)){const l=s[0],r=s[s.length-1];m.push(new g.LineRangeMapping(new g.LineRange(l.originalRange.startLineNumber,r.originalRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),new g.LineRange(l.modifiedRange.startLineNumber,r.modifiedRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),s))}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(m,(s,l)=>l.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===l.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<l.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<l.modifiedRange.startLineNumber)),m}n.lineRangeMappingFromRangeMappings=e;function*w(d,m){let s,l;for(const r of d)l!==void 0&&m(l,r)?s.push(r):(s&&(yield s),s=[r]),l=r;s&&(yield s)}class h{constructor(m,s){this.b=m,this.c=s}getElement(m){return this.b[m]}get length(){return this.b.length}getBoundaryScore(m){const s=m===0?0:C(this.c[m-1]),l=m===this.c.length?0:C(this.c[m]);return 1e3-(s+l)}}n.LineSequence=h;function C(d){let m=0;for(;m<d.length&&(d.charCodeAt(m)===32||d.charCodeAt(m)===9);)m++;return m}class v{constructor(m,s){this.lines=m,this.lineRange=s;let l=0;this.c=new Int32Array(s.length);for(let o=s.start;o<s.endExclusive;o++)l+=m[o].length,this.c[o-s.start]=l+1,l++;this.b=new Int32Array(l);let r=0;for(let o=s.start;o<s.endExclusive;o++){const c=m[o];for(let L=0;L<c.length;L++)this.b[r+L]=c.charCodeAt(L);r+=c.length,o<m.length-1&&(this.b[r]=`
`.charCodeAt(0),r+=1)}}getElement(m){return this.b[m]}get length(){return this.b.length}getBoundaryScore(m){const s=b(m>0?this.b[m-1]:-1),l=b(m<this.b.length?this.b[m]:-1);if(s===6&&l===7)return 0;let r=0;return s!==l&&(r+=10,l===1&&(r+=1)),r+=_(s),r+=_(l),r}translateOffset(m){let s=0,l=this.c.length;for(;s<l;){const o=Math.floor((s+l)/2);this.c[o]>m?l=o:s=o+1}const r=s===0?0:this.c[s-1];return new D.Position(s+1,m-r+1)}translateRange(m){return i.Range.fromPositions(this.translateOffset(m.start),this.translateOffset(m.endExclusive))}}const p={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function _(d){return p[d]}function b(d){return d===10?7:d===13?6:f(d)?5:d>=97&&d<=122?0:d>=65&&d<=90?1:d>=48&&d<=57?2:d===-1?3:4}function f(d){return d===32||d===9}}),Y(X[39],Q([0,1,37,38]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new E.SmartLinesDiffComputer,experimental:new D.StandardLinesDiffComputer}}),Y(X[40],Q([0,1,19]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(w,h,C){const v=new Uint8Array(w*h);for(let p=0,_=w*h;p<_;p++)v[p]=C;this.a=v,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,C){this.a[w*this.cols+h]=C}}class i{constructor(w){let h=0,C=0;for(let p=0,_=w.length;p<_;p++){const[b,f,d]=w[p];f>h&&(h=f),b>C&&(C=b),d>C&&(C=d)}h++,C++;const v=new D(C,h,0);for(let p=0,_=w.length;p<_;p++){const[b,f,d]=w[p];v.set(b,f,d)}this.a=v,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}n.StateMachine=i;let a=null;function y(){return a===null&&(a=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),a}let N=null;function u(){if(N===null){N=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)N.set(e.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)N.set(w.charCodeAt(h),2)}return N}class g{static a(w,h,C,v,p){let _=p-1;do{const b=h.charCodeAt(_);if(w.get(b)!==2)break;_--}while(_>v);if(v>0){const b=h.charCodeAt(v-1),f=h.charCodeAt(_);(b===40&&f===41||b===91&&f===93||b===123&&f===125)&&_--}return{range:{startLineNumber:C,startColumn:v+1,endLineNumber:C,endColumn:_+2},url:h.substring(v,_+1)}}static computeLinks(w,h=y()){const C=u(),v=[];for(let p=1,_=w.getLineCount();p<=_;p++){const b=w.getLineContent(p),f=b.length;let d=0,m=0,s=0,l=1,r=!1,o=!1,c=!1,L=!1;for(;d<f;){let A=!1;const R=b.charCodeAt(d);if(l===13){let M;switch(R){case 40:r=!0,M=0;break;case 41:M=r?0:1;break;case 91:c=!0,o=!0,M=0;break;case 93:c=!1,M=o?0:1;break;case 123:L=!0,M=0;break;case 125:M=L?0:1;break;case 39:case 34:case 96:s===R?M=1:s===39||s===34||s===96?M=0:M=1;break;case 42:M=s===42?1:0;break;case 124:M=s===124?1:0;break;case 32:M=c?0:1;break;default:M=C.get(R)}M===1&&(v.push(g.a(C,b,p,m,d)),A=!0)}else if(l===12){let M;R===91?(o=!0,M=0):M=C.get(R),M===1?A=!0:l=13}else l=h.nextState(l,R),l===0&&(A=!0);A&&(l=1,r=!1,o=!1,L=!1,m=d+1,s=R),d++}l===13&&v.push(g.a(C,b,p,m,f))}return v}}n.LinkComputer=g;function S(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:g.computeLinks(e)}n.computeLinks=S}),Y(X[41],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,a,y,N,u){if(i&&a){const g=this.a(a,u);if(g)return{range:i,value:g}}if(y&&N){const g=this.a(N,u);if(g)return{range:y,value:g}}return null}a(i,a){const y=this.b(i,a);return y!==null?y:this.d(i,a)}b(i,a){const y=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let N=Number(i);const u=parseFloat(i);return!isNaN(N)&&!isNaN(u)&&N===u?N===0&&!a?null:(N=Math.floor(N*y),N+=a?y:-y,String(N/y)):null}d(i,a){return this.e(this.c,i,a)}e(i,a,y){let N=null;for(let u=0,g=i.length;N===null&&u<g;u++)N=this.f(i[u],a,y);return N}f(i,a,y){let N=i.indexOf(a);return N>=0?(N+=y?1:-1,N<0?N=i.length-1:N%=i.length,i[N]):null}}E.INSTANCE=new E,n.BasicInplaceReplace=E}),Y(X[42],Q([0,1,11]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var D;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(D=n.OverviewRulerLane||(n.OverviewRulerLane={}));var i;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(i=n.MinimapPosition||(n.MinimapPosition={}));var a;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(a=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}n.TextModelResolvedOptions=y;class N{constructor(C,v){this._findMatchBrand=void 0,this.range=C,this.matches=v}}n.FindMatch=N;function u(h){return h&&typeof h.read=="function"}n.isITextSnapshot=u;class g{constructor(C,v,p,_,b,f){this.identifier=C,this.range=v,this.text=p,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=b,this._isTracked=f}}n.ValidAnnotatedEditOperation=g;class S{constructor(C,v,p){this.regex=C,this.wordSeparators=v,this.simpleSearch=p}}n.SearchData=S;class e{constructor(C,v,p){this.reverseEdits=C,this.changes=v,this.trimAutoWhitespaceLineNumbers=p}}n.ApplyEditsResult=e;function w(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=w}),Y(X[43],Q([0,1,24,18]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(u){this.a=u,this.b=new Uint32Array(u.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(u,g){u=(0,D.toUint32)(u);const S=this.a,e=this.b,w=g.length;return w===0?!1:(this.a=new Uint32Array(S.length+w),this.a.set(S.subarray(0,u),0),this.a.set(S.subarray(u),u+w),this.a.set(g,u),u-1<this.c[0]&&(this.c[0]=u-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}setValue(u,g){return u=(0,D.toUint32)(u),g=(0,D.toUint32)(g),this.a[u]===g?!1:(this.a[u]=g,u-1<this.c[0]&&(this.c[0]=u-1),!0)}removeValues(u,g){u=(0,D.toUint32)(u),g=(0,D.toUint32)(g);const S=this.a,e=this.b;if(u>=S.length)return!1;const w=S.length-u;return g>=w&&(g=w),g===0?!1:(this.a=new Uint32Array(S.length-g),this.a.set(S.subarray(0,u),0),this.a.set(S.subarray(u+g),u),this.b=new Uint32Array(this.a.length),u-1<this.c[0]&&(this.c[0]=u-1),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(u){return u<0?0:(u=(0,D.toUint32)(u),this.d(u))}d(u){if(u<=this.c[0])return this.b[u];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),u>=this.a.length&&(u=this.a.length-1);for(let S=g;S<=u;S++)this.b[S]=this.b[S-1]+this.a[S];return this.c[0]=Math.max(this.c[0],u),this.b[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let g=0,S=this.a.length-1,e=0,w=0,h=0;for(;g<=S;)if(e=g+(S-g)/2|0,w=this.b[e],h=w-this.a[e],u<h)S=e-1;else if(u>=w)g=e+1;else break;return new y(e,u-h)}}n.PrefixSumComputer=i;class a{constructor(u){this.a=u,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(u){return this.g(),u===0?0:this.d[u-1]}getIndexOf(u){this.g();const g=this.e[u],S=g>0?this.d[g-1]:0;return new y(g,u-S)}removeValues(u,g){this.a.splice(u,g),this.f(u)}insertValues(u,g){this.a=(0,E.arrayInsert)(this.a,u,g),this.f(u)}f(u){this.b=!1,this.c=Math.min(this.c,u-1)}g(){if(!this.b){for(let u=this.c+1,g=this.a.length;u<g;u++){const S=this.a[u],e=u>0?this.d[u-1]:0;this.d[u]=e+S;for(let w=0;w<S;w++)this.e[e+w]=u}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(u,g){this.a[u]!==g&&(this.a[u]=g,this.f(u))}}n.ConstantTimePrefixSumComputer=a;class y{constructor(u,g){this.index=u,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=g}}n.PrefixSumIndexOfResult=y}),Y(X[44],Q([0,1,4,3,43]),function(O,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class a{constructor(N,u,g,S){this.c=N,this.d=u,this.f=g,this.g=S,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(N){N.eol&&N.eol!==this.f&&(this.f=N.eol,this.h=null);const u=N.changes;for(const g of u)this.n(g.range),this.o(new D.Position(g.range.startLineNumber,g.range.startColumn),g.text);this.g=N.versionId,this.j=null}k(){if(!this.h){const N=this.f.length,u=this.d.length,g=new Uint32Array(u);for(let S=0;S<u;S++)g[S]=this.d[S].length+N;this.h=new i.PrefixSumComputer(g)}}l(N,u){this.d[N]=u,this.h&&this.h.setValue(N,this.d[N].length+this.f.length)}n(N){if(N.startLineNumber===N.endLineNumber){if(N.startColumn===N.endColumn)return;this.l(N.startLineNumber-1,this.d[N.startLineNumber-1].substring(0,N.startColumn-1)+this.d[N.startLineNumber-1].substring(N.endColumn-1));return}this.l(N.startLineNumber-1,this.d[N.startLineNumber-1].substring(0,N.startColumn-1)+this.d[N.endLineNumber-1].substring(N.endColumn-1)),this.d.splice(N.startLineNumber,N.endLineNumber-N.startLineNumber),this.h&&this.h.removeValues(N.startLineNumber,N.endLineNumber-N.startLineNumber)}o(N,u){if(u.length===0)return;const g=(0,E.splitLines)(u);if(g.length===1){this.l(N.lineNumber-1,this.d[N.lineNumber-1].substring(0,N.column-1)+g[0]+this.d[N.lineNumber-1].substring(N.column-1));return}g[g.length-1]+=this.d[N.lineNumber-1].substring(N.column-1),this.l(N.lineNumber-1,this.d[N.lineNumber-1].substring(0,N.column-1)+g[0]);const S=new Uint32Array(g.length-1);for(let e=1;e<g.length;e++)this.d.splice(N.lineNumber+e-1,0,g[e]),S[e-1]=g[e].length+this.f.length;this.h&&this.h.insertValues(N.lineNumber,S)}}n.MirrorTextModel=a}),Y(X[45],Q([0,1,4,32,3,2,42]),function(O,n,E,D,i,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const N=999;class u{constructor(b,f,d,m){this.searchString=b,this.isRegex=f,this.matchCase=d,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=g(this.searchString):b=this.searchString.indexOf(`
`)>=0;let f=null;try{f=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!f)return null;let d=!this.isRegex&&!b;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new y.SearchData(f,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}n.SearchParams=u;function g(_){if(!_||_.length===0)return!1;for(let b=0,f=_.length;b<f;b++){const d=_.charCodeAt(b);if(d===10)return!0;if(d===92){if(b++,b>=f)break;const m=_.charCodeAt(b);if(m===110||m===114||m===87)return!0}}return!1}n.isMultilineRegexSource=g;function S(_,b,f){if(!f)return new y.FindMatch(_,null);const d=[];for(let m=0,s=b.length;m<s;m++)d[m]=b[m];return new y.FindMatch(_,d)}n.createFindMatch=S;class e{constructor(b){const f=[];let d=0;for(let m=0,s=b.length;m<s;m++)b.charCodeAt(m)===10&&(f[d++]=m);this.a=f}findLineFeedCountBeforeOffset(b){const f=this.a;let d=0,m=f.length-1;if(m===-1||b<=f[0])return 0;for(;d<m;){const s=d+((m-d)/2>>0);f[s]>=b?m=s-1:f[s+1]>=b?(d=s,m=s):d=s+1}return d+1}}class w{static findMatches(b,f,d,m,s){const l=f.parseSearchRequest();return l?l.regex.multiline?this.b(b,d,new p(l.wordSeparators,l.regex),m,s):this.c(b,d,l,m,s):[]}static a(b,f,d,m,s,l){let r,o=0;m?(o=m.findLineFeedCountBeforeOffset(s),r=f+s+o):r=f+s;let c;if(m){const M=m.findLineFeedCountBeforeOffset(s+l.length)-o;c=r+l.length+M}else c=r+l.length;const L=b.getPositionAt(r),A=b.getPositionAt(c);return new a.Range(L.lineNumber,L.column,A.lineNumber,A.column)}static b(b,f,d,m,s){const l=b.getOffsetAt(f.getStartPosition()),r=b.getValueInRange(f,1),o=b.getEOL()===`\r
`?new e(r):null,c=[];let L=0,A;for(d.reset(0);A=d.next(r);)if(c[L++]=S(this.a(b,l,r,o,A.index,A[0]),A,m),L>=s)return c;return c}static c(b,f,d,m,s){const l=[];let r=0;if(f.startLineNumber===f.endLineNumber){const c=b.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this.d(d,c,f.startLineNumber,f.startColumn-1,r,l,m,s),l}const o=b.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this.d(d,o,f.startLineNumber,f.startColumn-1,r,l,m,s);for(let c=f.startLineNumber+1;c<f.endLineNumber&&r<s;c++)r=this.d(d,b.getLineContent(c),c,0,r,l,m,s);if(r<s){const c=b.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this.d(d,c,f.endLineNumber,0,r,l,m,s)}return l}static d(b,f,d,m,s,l,r,o){const c=b.wordSeparators;if(!r&&b.simpleSearch){const R=b.simpleSearch,M=R.length,T=f.length;let W=-M;for(;(W=f.indexOf(R,W+M))!==-1;)if((!c||v(c,f,T,W,M))&&(l[s++]=new y.FindMatch(new a.Range(d,W+1+m,d,W+1+M+m),null),s>=o))return s;return s}const L=new p(b.wordSeparators,b.regex);let A;L.reset(0);do if(A=L.next(f),A&&(l[s++]=S(new a.Range(d,A.index+1+m,d,A.index+1+A[0].length+m),A,r),s>=o))return s;while(A);return s}static findNextMatch(b,f,d,m){const s=f.parseSearchRequest();if(!s)return null;const l=new p(s.wordSeparators,s.regex);return s.regex.multiline?this.e(b,d,l,m):this.f(b,d,l,m)}static e(b,f,d,m){const s=new i.Position(f.lineNumber,1),l=b.getOffsetAt(s),r=b.getLineCount(),o=b.getValueInRange(new a.Range(s.lineNumber,s.column,r,b.getLineMaxColumn(r)),1),c=b.getEOL()===`\r
`?new e(o):null;d.reset(f.column-1);const L=d.next(o);return L?S(this.a(b,l,o,c,L.index,L[0]),L,m):f.lineNumber!==1||f.column!==1?this.e(b,new i.Position(1,1),d,m):null}static f(b,f,d,m){const s=b.getLineCount(),l=f.lineNumber,r=b.getLineContent(l),o=this.g(d,r,l,f.column,m);if(o)return o;for(let c=1;c<=s;c++){const L=(l+c-1)%s,A=b.getLineContent(L+1),R=this.g(d,A,L+1,1,m);if(R)return R}return null}static g(b,f,d,m,s){b.reset(m-1);const l=b.next(f);return l?S(new a.Range(d,l.index+1,d,l.index+1+l[0].length),l,s):null}static findPreviousMatch(b,f,d,m){const s=f.parseSearchRequest();if(!s)return null;const l=new p(s.wordSeparators,s.regex);return s.regex.multiline?this.h(b,d,l,m):this.j(b,d,l,m)}static h(b,f,d,m){const s=this.b(b,new a.Range(1,1,f.lineNumber,f.column),d,m,10*N);if(s.length>0)return s[s.length-1];const l=b.getLineCount();return f.lineNumber!==l||f.column!==b.getLineMaxColumn(l)?this.h(b,new i.Position(l,b.getLineMaxColumn(l)),d,m):null}static j(b,f,d,m){const s=b.getLineCount(),l=f.lineNumber,r=b.getLineContent(l).substring(0,f.column-1),o=this.k(d,r,l,m);if(o)return o;for(let c=1;c<=s;c++){const L=(s+l-c-1)%s,A=b.getLineContent(L+1),R=this.k(d,A,L+1,m);if(R)return R}return null}static k(b,f,d,m){let s=null,l;for(b.reset(0);l=b.next(f);)s=S(new a.Range(d,l.index+1,d,l.index+1+l[0].length),l,m);return s}}n.TextModelSearch=w;function h(_,b,f,d,m){if(d===0)return!0;const s=b.charCodeAt(d-1);if(_.get(s)!==0||s===13||s===10)return!0;if(m>0){const l=b.charCodeAt(d);if(_.get(l)!==0)return!0}return!1}function C(_,b,f,d,m){if(d+m===f)return!0;const s=b.charCodeAt(d+m);if(_.get(s)!==0||s===13||s===10)return!0;if(m>0){const l=b.charCodeAt(d+m-1);if(_.get(l)!==0)return!0}return!1}function v(_,b,f,d,m){return h(_,b,f,d,m)&&C(_,b,f,d,m)}n.isValidMatch=v;class p{constructor(b,f){this._wordSeparators=b,this.a=f,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const f=b.length;let d;do{if(this.b+this.c===f||(d=this.a.exec(b),!d))return null;const m=d.index,s=d[0].length;if(m===this.b&&s===this.c){if(s===0){E.getNextCodePoint(b,f,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=m,this.c=s,!this._wordSeparators||v(this._wordSeparators,b,f,m,s))return d}while(d);return null}}n.Searcher=p}),Y(X[46],Q([0,1,2,45,4,9,20]),function(O,n,E,D,i,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class N{static computeUnicodeHighlights(w,h,C){const v=C?C.startLineNumber:1,p=C?C.endLineNumber:w.getLineCount(),_=new g(h),b=_.getCandidateCodePoints();let f;b==="allNonBasicAscii"?f=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):f=new RegExp(`${u(Array.from(b))}`,"g");const d=new D.Searcher(null,f),m=[];let s=!1,l,r=0,o=0,c=0;e:for(let L=v,A=p;L<=A;L++){const R=w.getLineContent(L),M=R.length;d.reset(0);do if(l=d.next(R),l){let T=l.index,W=l.index+l[0].length;if(T>0){const k=R.charCodeAt(T-1);i.isHighSurrogate(k)&&T--}if(W+1<M){const k=R.charCodeAt(W-1);i.isHighSurrogate(k)&&W++}const I=R.substring(T,W);let q=(0,y.getWordAtText)(T+1,y.DEFAULT_WORD_REGEXP,R,0);q&&q.endColumn<=T+1&&(q=null);const H=_.shouldHighlightNonBasicASCII(I,q?q.word:null);if(H!==0){H===3?r++:H===2?o++:H===1?c++:(0,a.assertNever)(H);const k=1e3;if(m.length>=k){s=!0;break e}m.push(new E.Range(L,T+1,L,W+1))}}while(l)}return{ranges:m,hasMore:s,ambiguousCharacterCount:r,invisibleCharacterCount:o,nonBasicAsciiCharacterCount:c}}static computeUnicodeHighlightReason(w,h){const C=new g(h);switch(C.shouldHighlightNonBasicASCII(w,null)){case 0:return null;case 2:return{kind:1};case 3:{const p=w.codePointAt(0),_=C.ambiguousCharacters.getPrimaryConfusable(p),b=i.AmbiguousCharacters.getLocales().filter(f=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,f])).isAmbiguous(p));return{kind:0,confusableWith:String.fromCodePoint(_),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=N;function u(e,w){return`[${i.escapeRegExpCharacters(e.map(C=>String.fromCodePoint(C)).join(""))}]`}class g{constructor(w){this.b=w,this.a=new Set(w.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(w.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const w=new Set;if(this.b.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)S(String.fromCodePoint(h))||w.add(h);if(this.b.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())w.add(h);for(const h of this.a)w.delete(h);return w}shouldHighlightNonBasicASCII(w,h){const C=w.codePointAt(0);if(this.a.has(C))return 0;if(this.b.nonBasicASCII)return 1;let v=!1,p=!1;if(h)for(const _ of h){const b=_.codePointAt(0),f=i.isBasicASCII(_);v=v||f,!f&&!this.ambiguousCharacters.isAmbiguous(b)&&!i.InvisibleCharacters.isInvisibleCharacter(b)&&(p=!0)}return!v&&p?0:this.b.invisibleCharacters&&!S(w)&&i.InvisibleCharacters.isInvisibleCharacter(C)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(C)?3:0}}function S(e){return e===" "||e===`
`||e==="	"}}),Y(X[47],Q([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E=n.AccessibilitySupport||(n.AccessibilitySupport={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var a;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(a=n.CompletionItemKind||(n.CompletionItemKind={}));var y;(function(t){t[t.Deprecated=1]="Deprecated"})(y=n.CompletionItemTag||(n.CompletionItemTag={}));var N;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var u;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(u=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var g;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(g=n.CursorChangeReason||(n.CursorChangeReason={}));var S;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(S=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var w;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(w=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.colorDecoratorsLimit=18]="colorDecoratorsLimit",t[t.columnSelection=19]="columnSelection",t[t.comments=20]="comments",t[t.contextmenu=21]="contextmenu",t[t.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",t[t.cursorBlinking=23]="cursorBlinking",t[t.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",t[t.cursorStyle=25]="cursorStyle",t[t.cursorSurroundingLines=26]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",t[t.cursorWidth=28]="cursorWidth",t[t.disableLayerHinting=29]="disableLayerHinting",t[t.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",t[t.domReadOnly=31]="domReadOnly",t[t.dragAndDrop=32]="dragAndDrop",t[t.dropIntoEditor=33]="dropIntoEditor",t[t.emptySelectionClipboard=34]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",t[t.extraEditorClassName=36]="extraEditorClassName",t[t.fastScrollSensitivity=37]="fastScrollSensitivity",t[t.find=38]="find",t[t.fixedOverflowWidgets=39]="fixedOverflowWidgets",t[t.folding=40]="folding",t[t.foldingStrategy=41]="foldingStrategy",t[t.foldingHighlight=42]="foldingHighlight",t[t.foldingImportsByDefault=43]="foldingImportsByDefault",t[t.foldingMaximumRegions=44]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=46]="fontFamily",t[t.fontInfo=47]="fontInfo",t[t.fontLigatures=48]="fontLigatures",t[t.fontSize=49]="fontSize",t[t.fontWeight=50]="fontWeight",t[t.fontVariations=51]="fontVariations",t[t.formatOnPaste=52]="formatOnPaste",t[t.formatOnType=53]="formatOnType",t[t.glyphMargin=54]="glyphMargin",t[t.gotoLocation=55]="gotoLocation",t[t.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",t[t.hover=57]="hover",t[t.inDiffEditor=58]="inDiffEditor",t[t.inlineSuggest=59]="inlineSuggest",t[t.letterSpacing=60]="letterSpacing",t[t.lightbulb=61]="lightbulb",t[t.lineDecorationsWidth=62]="lineDecorationsWidth",t[t.lineHeight=63]="lineHeight",t[t.lineNumbers=64]="lineNumbers",t[t.lineNumbersMinChars=65]="lineNumbersMinChars",t[t.linkedEditing=66]="linkedEditing",t[t.links=67]="links",t[t.matchBrackets=68]="matchBrackets",t[t.minimap=69]="minimap",t[t.mouseStyle=70]="mouseStyle",t[t.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=72]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",t[t.multiCursorModifier=74]="multiCursorModifier",t[t.multiCursorPaste=75]="multiCursorPaste",t[t.multiCursorLimit=76]="multiCursorLimit",t[t.occurrencesHighlight=77]="occurrencesHighlight",t[t.overviewRulerBorder=78]="overviewRulerBorder",t[t.overviewRulerLanes=79]="overviewRulerLanes",t[t.padding=80]="padding",t[t.parameterHints=81]="parameterHints",t[t.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",t[t.quickSuggestions=84]="quickSuggestions",t[t.quickSuggestionsDelay=85]="quickSuggestionsDelay",t[t.readOnly=86]="readOnly",t[t.renameOnType=87]="renameOnType",t[t.renderControlCharacters=88]="renderControlCharacters",t[t.renderFinalNewline=89]="renderFinalNewline",t[t.renderLineHighlight=90]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=92]="renderValidationDecorations",t[t.renderWhitespace=93]="renderWhitespace",t[t.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",t[t.roundedSelection=95]="roundedSelection",t[t.rulers=96]="rulers",t[t.scrollbar=97]="scrollbar",t[t.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=99]="scrollBeyondLastLine",t[t.scrollPredominantAxis=100]="scrollPredominantAxis",t[t.selectionClipboard=101]="selectionClipboard",t[t.selectionHighlight=102]="selectionHighlight",t[t.selectOnLineNumbers=103]="selectOnLineNumbers",t[t.showFoldingControls=104]="showFoldingControls",t[t.showUnused=105]="showUnused",t[t.snippetSuggestions=106]="snippetSuggestions",t[t.smartSelect=107]="smartSelect",t[t.smoothScrolling=108]="smoothScrolling",t[t.stickyScroll=109]="stickyScroll",t[t.stickyTabStops=110]="stickyTabStops",t[t.stopRenderingLineAfter=111]="stopRenderingLineAfter",t[t.suggest=112]="suggest",t[t.suggestFontSize=113]="suggestFontSize",t[t.suggestLineHeight=114]="suggestLineHeight",t[t.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",t[t.suggestSelection=116]="suggestSelection",t[t.tabCompletion=117]="tabCompletion",t[t.tabIndex=118]="tabIndex",t[t.unicodeHighlighting=119]="unicodeHighlighting",t[t.unusualLineTerminators=120]="unusualLineTerminators",t[t.useShadowDOM=121]="useShadowDOM",t[t.useTabStops=122]="useTabStops",t[t.wordBreak=123]="wordBreak",t[t.wordSeparators=124]="wordSeparators",t[t.wordWrap=125]="wordWrap",t[t.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=128]="wordWrapColumn",t[t.wordWrapOverride1=129]="wordWrapOverride1",t[t.wordWrapOverride2=130]="wordWrapOverride2",t[t.wrappingIndent=131]="wrappingIndent",t[t.wrappingStrategy=132]="wrappingStrategy",t[t.showDeprecated=133]="showDeprecated",t[t.inlayHints=134]="inlayHints",t[t.editorClassName=135]="editorClassName",t[t.pixelRatio=136]="pixelRatio",t[t.tabFocusMode=137]="tabFocusMode",t[t.layoutInfo=138]="layoutInfo",t[t.wrappingInfo=139]="wrappingInfo"})(h=n.EditorOption||(n.EditorOption={}));var C;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(C=n.EndOfLinePreference||(n.EndOfLinePreference={}));var v;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(v=n.EndOfLineSequence||(n.EndOfLineSequence={}));var p;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(p=n.IndentAction||(n.IndentAction={}));var _;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(_=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var b;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(b=n.InlayHintKind||(n.InlayHintKind={}));var f;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(f=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var d;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(d=n.KeyCode||(n.KeyCode={}));var m;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(m=n.MarkerSeverity||(n.MarkerSeverity={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s=n.MarkerTag||(n.MarkerTag={}));var l;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(l=n.MinimapPosition||(n.MinimapPosition={}));var r;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(r=n.MouseTargetType||(n.MouseTargetType={}));var o;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(o=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var c;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(c=n.OverviewRulerLane||(n.OverviewRulerLane={}));var L;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(L=n.PositionAffinity||(n.PositionAffinity={}));var A;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(A=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var R;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(R=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var T;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(T=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var W;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(W=n.SelectionDirection||(n.SelectionDirection={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var q;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(q=n.SymbolKind||(n.SymbolKind={}));var H;(function(t){t[t.Deprecated=1]="Deprecated"})(H=n.SymbolTag||(n.SymbolTag={}));var k;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(k=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var U;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(U=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var F;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var V;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(V=n.WrappingIndent||(n.WrappingIndent={}))}),Y(X[48],Q([23,55]),function(O,n){return O.create("vs/base/common/platform",n)}),Y(X[6],Q([0,1,48]),function(O,n,E){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,a=!1,y=!1,N=!1,u=!1,g=!1,S=!1,e=!1,w=!1,h=!1,C,v=n.LANGUAGE_DEFAULT,p,_;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?b=n.globals.vscode.process:typeof process<"u"&&(b=process);const f=typeof((D=b?.versions)===null||D===void 0?void 0:D.electron)=="string",d=f&&b?.type==="renderer";if(typeof navigator=="object"&&!d)_=navigator.userAgent,i=_.indexOf("Windows")>=0,a=_.indexOf("Macintosh")>=0,e=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=_.indexOf("Linux")>=0,h=_?.indexOf("Mobi")>=0,g=!0,C=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,v=C;else if(typeof b=="object"){i=b.platform==="win32",a=b.platform==="darwin",y=b.platform==="linux",N=y&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,S=f,w=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=n.LANGUAGE_DEFAULT,v=n.LANGUAGE_DEFAULT;const o=b.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),L=c.availableLanguages["*"];C=c.locale,v=L||n.LANGUAGE_DEFAULT,p=c._translationsConfigFile}catch{}u=!0}else console.error("Unable to resolve platform.");let m=0;a?m=1:i?m=3:y&&(m=2),n.isWindows=i,n.isMacintosh=a,n.isLinux=y,n.isNative=u,n.isWeb=g,n.isWebWorker=g&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=_,n.language=v,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const o=[];n.globals.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let A=0,R=o.length;A<R;A++){const M=o[A];if(M.id===L.data.vscodeScheduleAsyncWork){o.splice(A,1),M.callback();return}}});let c=0;return L=>{const A=++c;o.push({id:A,callback:L}),n.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return o=>setTimeout(o)})(),n.OS=a||e?2:i?1:3;let s=!0,l=!1;function r(){if(!l){l=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=r,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[49],Q([0,1,6]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),Y(X[50],Q([0,1,49]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,a=90,y=122,N=46,u=47,g=92,S=58,e=63;class w extends Error{constructor(l,r,o){let c;typeof r=="string"&&r.indexOf("not ")===0?(c="must not be",r=r.replace(/^not /,"")):c="must be";const L=l.indexOf(".")!==-1?"property":"argument";let A=`The "${l}" ${L} ${c} of type ${r}`;A+=`. Received type ${typeof o}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,l){if(s===null||typeof s!="object")throw new w(l,"Object",s)}function C(s,l){if(typeof s!="string")throw new w(l,"string",s)}const v=E.platform==="win32";function p(s){return s===u||s===g}function _(s){return s===u}function b(s){return s>=D&&s<=a||s>=i&&s<=y}function f(s,l,r,o){let c="",L=0,A=-1,R=0,M=0;for(let T=0;T<=s.length;++T){if(T<s.length)M=s.charCodeAt(T);else{if(o(M))break;M=u}if(o(M)){if(!(A===T-1||R===1))if(R===2){if(c.length<2||L!==2||c.charCodeAt(c.length-1)!==N||c.charCodeAt(c.length-2)!==N){if(c.length>2){const W=c.lastIndexOf(r);W===-1?(c="",L=0):(c=c.slice(0,W),L=c.length-1-c.lastIndexOf(r)),A=T,R=0;continue}else if(c.length!==0){c="",L=0,A=T,R=0;continue}}l&&(c+=c.length>0?`${r}..`:"..",L=2)}else c.length>0?c+=`${r}${s.slice(A+1,T)}`:c=s.slice(A+1,T),L=T-A-1;A=T,R=0}else M===N&&R!==-1?++R:R=-1}return c}function d(s,l){h(l,"pathObject");const r=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${o}`:`${r}${s}${o}`:o}n.win32={resolve(...s){let l="",r="",o=!1;for(let c=s.length-1;c>=-1;c--){let L;if(c>=0){if(L=s[c],C(L,"path"),L.length===0)continue}else l.length===0?L=E.cwd():(L=E.env[`=${l}`]||E.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==l.toLowerCase()&&L.charCodeAt(2)===g)&&(L=`${l}\\`));const A=L.length;let R=0,M="",T=!1;const W=L.charCodeAt(0);if(A===1)p(W)&&(R=1,T=!0);else if(p(W))if(T=!0,p(L.charCodeAt(1))){let I=2,q=I;for(;I<A&&!p(L.charCodeAt(I));)I++;if(I<A&&I!==q){const H=L.slice(q,I);for(q=I;I<A&&p(L.charCodeAt(I));)I++;if(I<A&&I!==q){for(q=I;I<A&&!p(L.charCodeAt(I));)I++;(I===A||I!==q)&&(M=`\\\\${H}\\${L.slice(q,I)}`,R=I)}}}else R=1;else b(W)&&L.charCodeAt(1)===S&&(M=L.slice(0,2),R=2,A>2&&p(L.charCodeAt(2))&&(T=!0,R=3));if(M.length>0)if(l.length>0){if(M.toLowerCase()!==l.toLowerCase())continue}else l=M;if(o){if(l.length>0)break}else if(r=`${L.slice(R)}\\${r}`,o=T,T&&l.length>0)break}return r=f(r,!o,"\\",p),o?`${l}\\${r}`:`${l}${r}`||"."},normalize(s){C(s,"path");const l=s.length;if(l===0)return".";let r=0,o,c=!1;const L=s.charCodeAt(0);if(l===1)return _(L)?"\\":s;if(p(L))if(c=!0,p(s.charCodeAt(1))){let R=2,M=R;for(;R<l&&!p(s.charCodeAt(R));)R++;if(R<l&&R!==M){const T=s.slice(M,R);for(M=R;R<l&&p(s.charCodeAt(R));)R++;if(R<l&&R!==M){for(M=R;R<l&&!p(s.charCodeAt(R));)R++;if(R===l)return`\\\\${T}\\${s.slice(M)}\\`;R!==M&&(o=`\\\\${T}\\${s.slice(M,R)}`,r=R)}}}else r=1;else b(L)&&s.charCodeAt(1)===S&&(o=s.slice(0,2),r=2,l>2&&p(s.charCodeAt(2))&&(c=!0,r=3));let A=r<l?f(s.slice(r),!c,"\\",p):"";return A.length===0&&!c&&(A="."),A.length>0&&p(s.charCodeAt(l-1))&&(A+="\\"),o===void 0?c?`\\${A}`:A:c?`${o}\\${A}`:`${o}${A}`},isAbsolute(s){C(s,"path");const l=s.length;if(l===0)return!1;const r=s.charCodeAt(0);return p(r)||l>2&&b(r)&&s.charCodeAt(1)===S&&p(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let l,r;for(let L=0;L<s.length;++L){const A=s[L];C(A,"path"),A.length>0&&(l===void 0?l=r=A:l+=`\\${A}`)}if(l===void 0)return".";let o=!0,c=0;if(typeof r=="string"&&p(r.charCodeAt(0))){++c;const L=r.length;L>1&&p(r.charCodeAt(1))&&(++c,L>2&&(p(r.charCodeAt(2))?++c:o=!1))}if(o){for(;c<l.length&&p(l.charCodeAt(c));)c++;c>=2&&(l=`\\${l.slice(c)}`)}return n.win32.normalize(l)},relative(s,l){if(C(s,"from"),C(l,"to"),s===l)return"";const r=n.win32.resolve(s),o=n.win32.resolve(l);if(r===o||(s=r.toLowerCase(),l=o.toLowerCase(),s===l))return"";let c=0;for(;c<s.length&&s.charCodeAt(c)===g;)c++;let L=s.length;for(;L-1>c&&s.charCodeAt(L-1)===g;)L--;const A=L-c;let R=0;for(;R<l.length&&l.charCodeAt(R)===g;)R++;let M=l.length;for(;M-1>R&&l.charCodeAt(M-1)===g;)M--;const T=M-R,W=A<T?A:T;let I=-1,q=0;for(;q<W;q++){const k=s.charCodeAt(c+q);if(k!==l.charCodeAt(R+q))break;k===g&&(I=q)}if(q!==W){if(I===-1)return o}else{if(T>W){if(l.charCodeAt(R+q)===g)return o.slice(R+q+1);if(q===2)return o.slice(R+q)}A>W&&(s.charCodeAt(c+q)===g?I=q:q===2&&(I=3)),I===-1&&(I=0)}let H="";for(q=c+I+1;q<=L;++q)(q===L||s.charCodeAt(q)===g)&&(H+=H.length===0?"..":"\\..");return R+=I,H.length>0?`${H}${o.slice(R,M)}`:(o.charCodeAt(R)===g&&++R,o.slice(R,M))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const l=n.win32.resolve(s);if(l.length<=2)return s;if(l.charCodeAt(0)===g){if(l.charCodeAt(1)===g){const r=l.charCodeAt(2);if(r!==e&&r!==N)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(b(l.charCodeAt(0))&&l.charCodeAt(1)===S&&l.charCodeAt(2)===g)return`\\\\?\\${l}`;return s},dirname(s){C(s,"path");const l=s.length;if(l===0)return".";let r=-1,o=0;const c=s.charCodeAt(0);if(l===1)return p(c)?s:".";if(p(c)){if(r=o=1,p(s.charCodeAt(1))){let R=2,M=R;for(;R<l&&!p(s.charCodeAt(R));)R++;if(R<l&&R!==M){for(M=R;R<l&&p(s.charCodeAt(R));)R++;if(R<l&&R!==M){for(M=R;R<l&&!p(s.charCodeAt(R));)R++;if(R===l)return s;R!==M&&(r=o=R+1)}}}}else b(c)&&s.charCodeAt(1)===S&&(r=l>2&&p(s.charCodeAt(2))?3:2,o=r);let L=-1,A=!0;for(let R=l-1;R>=o;--R)if(p(s.charCodeAt(R))){if(!A){L=R;break}}else A=!1;if(L===-1){if(r===-1)return".";L=r}return s.slice(0,L)},basename(s,l){l!==void 0&&C(l,"ext"),C(s,"path");let r=0,o=-1,c=!0,L;if(s.length>=2&&b(s.charCodeAt(0))&&s.charCodeAt(1)===S&&(r=2),l!==void 0&&l.length>0&&l.length<=s.length){if(l===s)return"";let A=l.length-1,R=-1;for(L=s.length-1;L>=r;--L){const M=s.charCodeAt(L);if(p(M)){if(!c){r=L+1;break}}else R===-1&&(c=!1,R=L+1),A>=0&&(M===l.charCodeAt(A)?--A===-1&&(o=L):(A=-1,o=R))}return r===o?o=R:o===-1&&(o=s.length),s.slice(r,o)}for(L=s.length-1;L>=r;--L)if(p(s.charCodeAt(L))){if(!c){r=L+1;break}}else o===-1&&(c=!1,o=L+1);return o===-1?"":s.slice(r,o)},extname(s){C(s,"path");let l=0,r=-1,o=0,c=-1,L=!0,A=0;s.length>=2&&s.charCodeAt(1)===S&&b(s.charCodeAt(0))&&(l=o=2);for(let R=s.length-1;R>=l;--R){const M=s.charCodeAt(R);if(p(M)){if(!L){o=R+1;break}continue}c===-1&&(L=!1,c=R+1),M===N?r===-1?r=R:A!==1&&(A=1):r!==-1&&(A=-1)}return r===-1||c===-1||A===0||A===1&&r===c-1&&r===o+1?"":s.slice(r,c)},format:d.bind(null,"\\"),parse(s){C(s,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return l;const r=s.length;let o=0,c=s.charCodeAt(0);if(r===1)return p(c)?(l.root=l.dir=s,l):(l.base=l.name=s,l);if(p(c)){if(o=1,p(s.charCodeAt(1))){let I=2,q=I;for(;I<r&&!p(s.charCodeAt(I));)I++;if(I<r&&I!==q){for(q=I;I<r&&p(s.charCodeAt(I));)I++;if(I<r&&I!==q){for(q=I;I<r&&!p(s.charCodeAt(I));)I++;I===r?o=I:I!==q&&(o=I+1)}}}}else if(b(c)&&s.charCodeAt(1)===S){if(r<=2)return l.root=l.dir=s,l;if(o=2,p(s.charCodeAt(2))){if(r===3)return l.root=l.dir=s,l;o=3}}o>0&&(l.root=s.slice(0,o));let L=-1,A=o,R=-1,M=!0,T=s.length-1,W=0;for(;T>=o;--T){if(c=s.charCodeAt(T),p(c)){if(!M){A=T+1;break}continue}R===-1&&(M=!1,R=T+1),c===N?L===-1?L=T:W!==1&&(W=1):L!==-1&&(W=-1)}return R!==-1&&(L===-1||W===0||W===1&&L===R-1&&L===A+1?l.base=l.name=s.slice(A,R):(l.name=s.slice(A,L),l.base=s.slice(A,R),l.ext=s.slice(L,R))),A>0&&A!==o?l.dir=s.slice(0,A-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(v){const s=/\\/g;return()=>{const l=E.cwd().replace(s,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...s){let l="",r=!1;for(let o=s.length-1;o>=-1&&!r;o--){const c=o>=0?s[o]:m();C(c,"path"),c.length!==0&&(l=`${c}/${l}`,r=c.charCodeAt(0)===u)}return l=f(l,!r,"/",_),r?`/${l}`:l.length>0?l:"."},normalize(s){if(C(s,"path"),s.length===0)return".";const l=s.charCodeAt(0)===u,r=s.charCodeAt(s.length-1)===u;return s=f(s,!l,"/",_),s.length===0?l?"/":r?"./":".":(r&&(s+="/"),l?`/${s}`:s)},isAbsolute(s){return C(s,"path"),s.length>0&&s.charCodeAt(0)===u},join(...s){if(s.length===0)return".";let l;for(let r=0;r<s.length;++r){const o=s[r];C(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":n.posix.normalize(l)},relative(s,l){if(C(s,"from"),C(l,"to"),s===l||(s=n.posix.resolve(s),l=n.posix.resolve(l),s===l))return"";const r=1,o=s.length,c=o-r,L=1,A=l.length-L,R=c<A?c:A;let M=-1,T=0;for(;T<R;T++){const I=s.charCodeAt(r+T);if(I!==l.charCodeAt(L+T))break;I===u&&(M=T)}if(T===R)if(A>R){if(l.charCodeAt(L+T)===u)return l.slice(L+T+1);if(T===0)return l.slice(L+T)}else c>R&&(s.charCodeAt(r+T)===u?M=T:T===0&&(M=0));let W="";for(T=r+M+1;T<=o;++T)(T===o||s.charCodeAt(T)===u)&&(W+=W.length===0?"..":"/..");return`${W}${l.slice(L+M)}`},toNamespacedPath(s){return s},dirname(s){if(C(s,"path"),s.length===0)return".";const l=s.charCodeAt(0)===u;let r=-1,o=!0;for(let c=s.length-1;c>=1;--c)if(s.charCodeAt(c)===u){if(!o){r=c;break}}else o=!1;return r===-1?l?"/":".":l&&r===1?"//":s.slice(0,r)},basename(s,l){l!==void 0&&C(l,"ext"),C(s,"path");let r=0,o=-1,c=!0,L;if(l!==void 0&&l.length>0&&l.length<=s.length){if(l===s)return"";let A=l.length-1,R=-1;for(L=s.length-1;L>=0;--L){const M=s.charCodeAt(L);if(M===u){if(!c){r=L+1;break}}else R===-1&&(c=!1,R=L+1),A>=0&&(M===l.charCodeAt(A)?--A===-1&&(o=L):(A=-1,o=R))}return r===o?o=R:o===-1&&(o=s.length),s.slice(r,o)}for(L=s.length-1;L>=0;--L)if(s.charCodeAt(L)===u){if(!c){r=L+1;break}}else o===-1&&(c=!1,o=L+1);return o===-1?"":s.slice(r,o)},extname(s){C(s,"path");let l=-1,r=0,o=-1,c=!0,L=0;for(let A=s.length-1;A>=0;--A){const R=s.charCodeAt(A);if(R===u){if(!c){r=A+1;break}continue}o===-1&&(c=!1,o=A+1),R===N?l===-1?l=A:L!==1&&(L=1):l!==-1&&(L=-1)}return l===-1||o===-1||L===0||L===1&&l===o-1&&l===r+1?"":s.slice(l,o)},format:d.bind(null,"/"),parse(s){C(s,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return l;const r=s.charCodeAt(0)===u;let o;r?(l.root="/",o=1):o=0;let c=-1,L=0,A=-1,R=!0,M=s.length-1,T=0;for(;M>=o;--M){const W=s.charCodeAt(M);if(W===u){if(!R){L=M+1;break}continue}A===-1&&(R=!1,A=M+1),W===N?c===-1?c=M:T!==1&&(T=1):c!==-1&&(T=-1)}if(A!==-1){const W=L===0&&r?1:L;c===-1||T===0||T===1&&c===A-1&&c===L+1?l.base=l.name=s.slice(W,A):(l.name=s.slice(W,c),l.base=s.slice(W,A),l.ext=s.slice(c,A))}return L>0?l.dir=s.slice(0,L-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=v?n.win32.normalize:n.posix.normalize,n.resolve=v?n.win32.resolve:n.posix.resolve,n.relative=v?n.win32.relative:n.posix.relative,n.dirname=v?n.win32.dirname:n.posix.dirname,n.basename=v?n.win32.basename:n.posix.basename,n.extname=v?n.win32.extname:n.posix.extname,n.sep=v?n.win32.sep:n.posix.sep}),Y(X[22],Q([0,1,6]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const D=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(y=!0){return new i(y)}constructor(y){this.a=D&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}n.StopWatch=i}),Y(X[7],Q([0,1,8,13,10,15,22]),function(O,n,E,D,i,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.EventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const N=!1,u=!1;var g;(function(o){o.None=()=>i.Disposable.None;function c(J){if(u){const{onDidAddListener:j}=J,G=h.create();let $=0;J.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),j?.()}}}function L(J,j){return k(J,()=>{},0,void 0,!0,void 0,j)}o.defer=L;function A(J){return(j,G=null,$)=>{let K=!1,ee;return ee=J(te=>{if(!K)return ee?ee.dispose():K=!0,j.call(G,te)},null,$),K&&ee.dispose(),ee}}o.once=A;function R(J,j,G){return H(($,K=null,ee)=>J(te=>$.call(K,j(te)),null,ee),G)}o.map=R;function M(J,j,G){return H(($,K=null,ee)=>J(te=>{j(te),$.call(K,te)},null,ee),G)}o.forEach=M;function T(J,j,G){return H(($,K=null,ee)=>J(te=>j(te)&&$.call(K,te),null,ee),G)}o.filter=T;function W(J){return J}o.signal=W;function I(...J){return(j,G=null,$)=>(0,i.combinedDisposable)(...J.map(K=>K(ee=>j.call(G,ee),null,$)))}o.any=I;function q(J,j,G,$){let K=G;return R(J,ee=>(K=j(K,ee),K),$)}o.reduce=q;function H(J,j){let G;const $={onWillAddFirstListener(){G=J(K.fire,K)},onDidRemoveLastListener(){G?.dispose()}};j||c($);const K=new v($);return j?.add(K),K.event}function k(J,j,G=100,$=!1,K=!1,ee,te){let ae,be,ve,oe=0,ce;const P={leakWarningThreshold:ee,onWillAddFirstListener(){ae=J(x=>{oe++,be=j(be,x),$&&!ve&&(B.fire(be),be=void 0),ce=()=>{const z=be;be=void 0,ve=void 0,(!$||oe>1)&&B.fire(z),oe=0},typeof G=="number"?(clearTimeout(ve),ve=setTimeout(ce,G)):ve===void 0&&(ve=0,queueMicrotask(ce))})},onWillRemoveListener(){K&&oe>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,ae.dispose()}};te||c(P);const B=new v(P);return te?.add(B),B.event}o.debounce=k;function U(J,j=0,G){return o.debounce(J,($,K)=>$?($.push(K),$):[K],j,void 0,!0,void 0,G)}o.accumulate=U;function F(J,j=($,K)=>$===K,G){let $=!0,K;return T(J,ee=>{const te=$||!j(ee,K);return $=!1,K=ee,te},G)}o.latch=F;function V(J,j,G){return[o.filter(J,j,G),o.filter(J,$=>!j($),G)]}o.split=V;function t(J,j=!1,G=[]){let $=G.slice(),K=J(ae=>{$?$.push(ae):te.fire(ae)});const ee=()=>{$?.forEach(ae=>te.fire(ae)),$=null},te=new v({onWillAddFirstListener(){K||(K=J(ae=>te.fire(ae)))},onDidAddFirstListener(){$&&(j?setTimeout(ee):ee())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return te.event}o.buffer=t;class ne{constructor(j){this.event=j,this.c=new i.DisposableStore}map(j){return new ne(R(this.event,j,this.c))}forEach(j){return new ne(M(this.event,j,this.c))}filter(j){return new ne(T(this.event,j,this.c))}reduce(j,G){return new ne(q(this.event,j,G,this.c))}latch(){return new ne(F(this.event,void 0,this.c))}debounce(j,G=100,$=!1,K=!1,ee){return new ne(k(this.event,j,G,$,K,ee,this.c))}on(j,G,$){return this.event(j,G,$)}once(j,G,$){return A(this.event)(j,G,$)}dispose(){this.c.dispose()}}function le(J){return new ne(J)}o.chain=le;function de(J,j,G=$=>$){const $=(...ae)=>te.fire(G(...ae)),K=()=>J.on(j,$),ee=()=>J.removeListener(j,$),te=new v({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}o.fromNodeEventEmitter=de;function we(J,j,G=$=>$){const $=(...ae)=>te.fire(G(...ae)),K=()=>J.addEventListener(j,$),ee=()=>J.removeEventListener(j,$),te=new v({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}o.fromDOMEventEmitter=we;function ye(J){return new Promise(j=>A(J)(j))}o.toPromise=ye;function pe(J,j){return j(void 0),J(G=>j(G))}o.runAndSubscribe=pe;function Se(J,j){let G=null;function $(ee){G?.dispose(),G=new i.DisposableStore,j(ee,G)}$(void 0);const K=J(ee=>$(ee));return(0,i.toDisposable)(()=>{K.dispose(),G?.dispose()})}o.runAndSubscribeWithStore=Se;class Ne{constructor(j,G){this.obs=j,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};G||c($),this.emitter=new v($),G&&G.add(this.emitter)}beginUpdate(j){this.c++}handleChange(j,G){this.d=!0}endUpdate(j){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function _e(J,j){return new Ne(J,j).emitter.event}o.fromObservable=_e})(g=n.Event||(n.Event={}));class S{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${S.c++}`,S.all.add(this)}start(c){this.d=new y.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}S.all=new Set,S.c=0,n.EventProfiling=S;let e=-1;class w{constructor(c,L=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=L,this.d=0}dispose(){var c;(c=this.c)===null||c===void 0||c.clear()}check(c,L){const A=this.threshold;if(A<=0||L<A)return;this.c||(this.c=new Map);const R=this.c.get(c.value)||0;if(this.c.set(c.value,R+1),this.d-=1,this.d<=0){this.d=A*.5;let M,T=0;for(const[W,I]of this.c)(!M||T<I)&&(M=W,T=I);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${T}):`),console.warn(M)}return()=>{const M=this.c.get(c.value)||0;this.c.set(c.value,M-1)}}}class h{static create(){var c;return new h((c=new Error().stack)!==null&&c!==void 0?c:"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(c,L,A){this.callback=c,this.callbackThis=L,this.stack=A,this.subscription=new i.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class v{constructor(c){var L,A,R,M,T;this.j=!1,this.d=c,this.f=e>0||((L=this.d)===null||L===void 0?void 0:L.leakWarningThreshold)?new w((R=(A=this.d)===null||A===void 0?void 0:A.leakWarningThreshold)!==null&&R!==void 0?R:e):void 0,this.g=!((M=this.d)===null||M===void 0)&&M._profName?new S(this.d._profName):void 0,this.m=(T=this.d)===null||T===void 0?void 0:T.deliveryQueue}dispose(){var c,L,A,R;if(!this.j){if(this.j=!0,this.n){if(N){const M=Array.from(this.n);queueMicrotask(()=>{var T;for(const W of M)W.subscription.isset()&&(W.subscription.unset(),(T=W.stack)===null||T===void 0||T.print())})}this.n.clear()}(c=this.m)===null||c===void 0||c.clear(this),(A=(L=this.d)===null||L===void 0?void 0:L.onDidRemoveLastListener)===null||A===void 0||A.call(L),(R=this.f)===null||R===void 0||R.dispose()}}get event(){return this.l||(this.l=(c,L,A)=>{var R,M,T;if(this.n||(this.n=new a.LinkedList),this.f&&this.n.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const W=this.n.isEmpty();W&&((R=this.d)===null||R===void 0?void 0:R.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this);let I,q;this.f&&this.n.size>=Math.ceil(this.f.threshold*.2)&&(q=h.create(),I=this.f.check(q,this.n.size+1)),N&&(q=q??h.create());const H=new C(c,L,q),k=this.n.push(H);W&&((M=this.d)===null||M===void 0?void 0:M.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),!((T=this.d)===null||T===void 0)&&T.onDidAddListener&&this.d.onDidAddListener(this,c,L);const U=H.subscription.set(()=>{var F,V;I?.(),this.j||((V=(F=this.d)===null||F===void 0?void 0:F.onWillRemoveListener)===null||V===void 0||V.call(F,this),k(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))});return A instanceof i.DisposableStore?A.add(U):Array.isArray(A)&&A.push(U),U}),this.l}fire(c){var L,A,R;if(this.n){this.m||(this.m=new _((L=this.d)===null||L===void 0?void 0:L.onListenerError));for(const M of this.n)this.m.push(this,M,c);(A=this.g)===null||A===void 0||A.start(this.m.size),this.m.deliver(),(R=this.g)===null||R===void 0||R.stop()}}hasListeners(){return this.n?!this.n.isEmpty():!1}}n.Emitter=v;class p{constructor(c=E.onUnexpectedError){this.d=c,this.c=new a.LinkedList}get size(){return this.c.size}push(c,L,A){this.c.push(new b(c,L,A))}clear(c){const L=new a.LinkedList;for(const A of this.c)A.emitter!==c&&L.push(A);this.c=L}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(L){this.d(L)}}}}n.EventDeliveryQueue=p;class _ extends p{clear(c){this.c.clear()}}class b{constructor(c,L,A){this.emitter=c,this.listener=L,this.event=A}}class f extends v{constructor(c){super(c),this.c=0,this.h=new a.LinkedList,this.k=c?.merge}pause(){this.c++}resume(){if(this.c!==0&&--this.c===0)if(this.k){if(this.h.size>0){const c=Array.from(this.h);this.h.clear(),super.fire(this.k(c))}}else for(;!this.c&&this.h.size!==0;)super.fire(this.h.shift())}fire(c){this.n&&(this.c!==0?this.h.push(c):super.fire(c))}}n.PauseableEmitter=f;class d extends f{constructor(c){var L;super(c),this.o=(L=c.delay)!==null&&L!==void 0?L:100}fire(c){this.p||(this.pause(),this.p=setTimeout(()=>{this.p=void 0,this.resume()},this.o)),super.fire(c)}}n.DebounceEmitter=d;class m extends v{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){!this.hasListeners()||(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(L=>super.fire(L)),this.c=[]}))}}n.MicrotaskEmitter=m;class s{constructor(){this.d=!1,this.f=[],this.c=new v({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const L={event:c,listener:null};this.f.push(L),this.d&&this.j(L);const A=()=>{this.d&&this.k(L);const R=this.f.indexOf(L);this.f.splice(R,1)};return(0,i.toDisposable)((0,D.once)(A))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(L=>this.c.fire(L))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}n.EventMultiplexer=s;class l{constructor(){this.c=[]}wrapEvent(c){return(L,A,R)=>c(M=>{const T=this.c[this.c.length-1];T?T.push(()=>L.call(A,M)):L.call(A,M)},void 0,R)}bufferEvents(c){const L=[];this.c.push(L);const A=c();return this.c.pop(),L.forEach(R=>R()),A}}n.EventBufferer=l;class r{constructor(){this.c=!1,this.d=g.None,this.f=i.Disposable.None,this.g=new v({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}n.Relay=r}),Y(X[51],Q([0,1,7]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(N,u){const g=setTimeout(N.bind(u),0);return{dispose(){clearTimeout(g)}}});var i;(function(N){function u(g){return g===N.None||g===N.Cancelled||g instanceof a?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}N.isCancellationToken=u,N.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),N.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i=n.CancellationToken||(n.CancellationToken={}));class a{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(u){this.a=void 0,this.b=void 0,this.b=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new a),this.a}cancel(){this.a?this.a instanceof a&&this.a.cancel():this.a=i.Cancelled}dispose(u=!1){var g;u&&this.cancel(),(g=this.b)===null||g===void 0||g.dispose(),this.a?this.a instanceof a&&this.a.dispose():this.a=i.None}}n.CancellationTokenSource=y}),Y(X[12],Q([0,1,50,6]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,a=/^\//,y=/^\/\//;function N(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!i.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!a.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(r,o){return!r&&!o?"file":r}function g(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==e&&(o=e+o):o=e;break}return o}const S="",e="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(o){return o instanceof h?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,c,L,A,R,M=!1){typeof o=="object"?(this.scheme=o.scheme||S,this.authority=o.authority||S,this.path=o.path||S,this.query=o.query||S,this.fragment=o.fragment||S):(this.scheme=u(o,M),this.authority=c||S,this.path=g(this.scheme,L||S),this.query=A||S,this.fragment=R||S,N(this,M))}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:L,path:A,query:R,fragment:M}=o;return c===void 0?c=this.scheme:c===null&&(c=S),L===void 0?L=this.authority:L===null&&(L=S),A===void 0?A=this.path:A===null&&(A=S),R===void 0?R=this.query:R===null&&(R=S),M===void 0?M=this.fragment:M===null&&(M=S),c===this.scheme&&L===this.authority&&A===this.path&&R===this.query&&M===this.fragment?this:new v(c,L,A,R,M)}static parse(o,c=!1){const L=w.exec(o);return L?new v(L[2]||S,l(L[4]||S),l(L[5]||S),l(L[7]||S),l(L[9]||S),c):new v(S,S,S,S,S)}static file(o){let c=S;if(D.isWindows&&(o=o.replace(/\\/g,e)),o[0]===e&&o[1]===e){const L=o.indexOf(e,2);L===-1?(c=o.substring(2),o=e):(c=o.substring(2,L),o=o.substring(L)||e)}return new v("file",c,o,S,S)}static from(o){const c=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return N(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return D.isWindows&&o.scheme==="file"?L=h.file(E.win32.join(f(o,!0),...c)).path:L=E.posix.join(o.path,...c),o.with({path:L})}toString(o=!1){return d(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof h)return o;{const c=new v(o);return c._formatted=o.external,c._fsPath=o._sep===C?o.fsPath:null,c}}else return o}}n.URI=h;const C=D.isWindows?1:void 0;class v extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=C),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,o,c){let L,A=-1;for(let R=0;R<r.length;R++){const M=r.charCodeAt(R);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||o&&M===47||c&&M===91||c&&M===93||c&&M===58)A!==-1&&(L+=encodeURIComponent(r.substring(A,R)),A=-1),L!==void 0&&(L+=r.charAt(R));else{L===void 0&&(L=r.substr(0,R));const T=p[M];T!==void 0?(A!==-1&&(L+=encodeURIComponent(r.substring(A,R)),A=-1),L+=T):A===-1&&(A=R)}}return A!==-1&&(L+=encodeURIComponent(r.substring(A))),L!==void 0?L:r}function b(r){let o;for(let c=0;c<r.length;c++){const L=r.charCodeAt(c);L===35||L===63?(o===void 0&&(o=r.substr(0,c)),o+=p[L]):o!==void 0&&(o+=r[c])}return o!==void 0?o:r}function f(r,o){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,D.isWindows&&(c=c.replace(/\//g,"\\")),c}n.uriToFsPath=f;function d(r,o){const c=o?b:_;let L="",{scheme:A,authority:R,path:M,query:T,fragment:W}=r;if(A&&(L+=A,L+=":"),(R||A==="file")&&(L+=e,L+=e),R){let I=R.indexOf("@");if(I!==-1){const q=R.substr(0,I);R=R.substr(I+1),I=q.lastIndexOf(":"),I===-1?L+=c(q,!1,!1):(L+=c(q.substr(0,I),!1,!1),L+=":",L+=c(q.substr(I+1),!1,!0)),L+="@"}R=R.toLowerCase(),I=R.lastIndexOf(":"),I===-1?L+=c(R,!1,!0):(L+=c(R.substr(0,I),!1,!0),L+=R.substr(I))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const I=M.charCodeAt(1);I>=65&&I<=90&&(M=`/${String.fromCharCode(I+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const I=M.charCodeAt(0);I>=65&&I<=90&&(M=`${String.fromCharCode(I+32)}:${M.substr(2)}`)}L+=c(M,!0,!1)}return T&&(L+="?",L+=c(T,!1,!1)),W&&(L+="#",L+=o?W:_(W,!1,!1)),L}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(s)?r.replace(s,o=>m(o)):r}}),Y(X[56],Q([0,1,8,7,10,11,6,4]),function(O,n,E,D,i,a,y,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const u="$initialize";let g=!1;function S(l){!y.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}n.logOnceWebWorkerWarning=S;class e{constructor(r,o,c,L){this.vsWorker=r,this.req=o,this.method=c,this.args=L,this.type=0}}class w{constructor(r,o,c,L){this.vsWorker=r,this.seq=o,this.res=c,this.err=L,this.type=1}}class h{constructor(r,o,c,L){this.vsWorker=r,this.req=o,this.eventName=c,this.arg=L,this.type=2}}class C{constructor(r,o,c){this.vsWorker=r,this.req=o,this.event=c,this.type=3}}class v{constructor(r,o){this.vsWorker=r,this.req=o,this.type=4}}class p{constructor(r){this.a=-1,this.g=r,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(r){this.a=r}sendMessage(r,o){const c=String(++this.b);return new Promise((L,A)=>{this.c[c]={resolve:L,reject:A},this.o(new e(this.a,c,r,o))})}listen(r,o){let c=null;const L=new D.Emitter({onWillAddFirstListener:()=>{c=String(++this.b),this.d.set(c,L),this.o(new h(this.a,c,r,o))},onDidRemoveLastListener:()=>{this.d.delete(c),this.o(new v(this.a,c)),c=null}});return L.event}handleMessage(r){!r||!r.vsWorker||this.a!==-1&&r.vsWorker!==this.a||this.h(r)}h(r){switch(r.type){case 1:return this.j(r);case 0:return this.k(r);case 2:return this.l(r);case 3:return this.m(r);case 4:return this.n(r)}}j(r){if(!this.c[r.seq]){console.warn("Got reply to unknown seq");return}const o=this.c[r.seq];if(delete this.c[r.seq],r.err){let c=r.err;r.err.$isError&&(c=new Error,c.name=r.err.name,c.message=r.err.message,c.stack=r.err.stack),o.reject(c);return}o.resolve(r.res)}k(r){const o=r.req;this.g.handleMessage(r.method,r.args).then(L=>{this.o(new w(this.a,o,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,E.transformErrorForSerialization)(L.detail)),this.o(new w(this.a,o,void 0,(0,E.transformErrorForSerialization)(L)))})}l(r){const o=r.req,c=this.g.handleEvent(r.eventName,r.arg)(L=>{this.o(new C(this.a,o,L))});this.f.set(o,c)}m(r){if(!this.d.has(r.req)){console.warn("Got event for unknown req");return}this.d.get(r.req).fire(r.event)}n(r){if(!this.f.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(r.req).dispose(),this.f.delete(r.req)}o(r){const o=[];if(r.type===0)for(let c=0;c<r.args.length;c++)r.args[c]instanceof ArrayBuffer&&o.push(r.args[c]);else r.type===1&&r.res instanceof ArrayBuffer&&o.push(r.res);this.g.sendMessage(r,o)}}class _ extends i.Disposable{constructor(r,o,c){super();let L=null;this.a=this.q(r.create("vs/base/common/worker/simpleWorker",I=>{this.c.handleMessage(I)},I=>{L?.(I)})),this.c=new p({sendMessage:(I,q)=>{this.a.postMessage(I,q)},handleMessage:(I,q)=>{if(typeof c[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(c[I].apply(c,q))}catch(H){return Promise.reject(H)}},handleEvent:(I,q)=>{if(f(I)){const H=c[I].call(c,q);if(typeof H!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return H}if(b(I)){const H=c[I];if(typeof H!="function")throw new Error(`Missing event ${I} on main thread host.`);return H}throw new Error(`Malformed event name ${I}`)}}),this.c.setWorkerId(this.a.getId());let A=null;const R=globalThis.require;typeof R<"u"&&typeof R.getConfig=="function"?A=R.getConfig():typeof globalThis.requirejs<"u"&&(A=globalThis.requirejs.s.contexts._.config);const M=(0,a.getAllMethodNames)(c);this.b=this.c.sendMessage(u,[this.a.getId(),JSON.parse(JSON.stringify(A)),o,M]);const T=(I,q)=>this.h(I,q),W=(I,q)=>this.c.listen(I,q);this.g=new Promise((I,q)=>{L=q,this.b.then(H=>{I(d(H,T,W))},H=>{q(H),this.j("Worker failed to load "+o,H)})})}getProxyObject(){return this.g}h(r,o){return new Promise((c,L)=>{this.b.then(()=>{this.c.sendMessage(r,o).then(c,L)},L)})}j(r,o){console.error(r),console.info(o)}}n.SimpleWorkerClient=_;function b(l){return l[0]==="o"&&l[1]==="n"&&N.isUpperAsciiLetter(l.charCodeAt(2))}function f(l){return/^onDynamic/.test(l)&&N.isUpperAsciiLetter(l.charCodeAt(9))}function d(l,r,o){const c=R=>function(){const M=Array.prototype.slice.call(arguments,0);return r(R,M)},L=R=>function(M){return o(R,M)},A={};for(const R of l){if(f(R)){A[R]=L(R);continue}if(b(R)){A[R]=o(R,void 0);continue}A[R]=c(R)}return A}class m{constructor(r,o){this.a=o,this.b=null,this.c=new p({sendMessage:(c,L)=>{r(c,L)},handleMessage:(c,L)=>this.d(c,L),handleEvent:(c,L)=>this.f(c,L)})}onmessage(r){this.c.handleMessage(r)}d(r,o){if(r===u)return this.g(o[0],o[1],o[2],o[3]);if(!this.b||typeof this.b[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.b[r].apply(this.b,o))}catch(c){return Promise.reject(c)}}f(r,o){if(!this.b)throw new Error("Missing requestHandler");if(f(r)){const c=this.b[r].call(this.b,o);if(typeof c!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return c}if(b(r)){const c=this.b[r];if(typeof c!="function")throw new Error(`Missing event ${r} on request handler.`);return c}throw new Error(`Malformed event name ${r}`)}g(r,o,c,L){this.c.setWorkerId(r);const M=d(L,(T,W)=>this.c.sendMessage(T,W),(T,W)=>this.c.listen(T,W));return this.a?(this.b=this.a(M),Promise.resolve((0,a.getAllMethodNames)(this.b))):(o&&(typeof o.baseUrl<"u"&&delete o.baseUrl,typeof o.paths<"u"&&typeof o.paths.vs<"u"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,globalThis.require.config(o)),new Promise((T,W)=>{(globalThis.require||O)([c],q=>{if(this.b=q.create(M),!this.b){W(new Error("No RequestHandler!"));return}T((0,a.getAllMethodNames)(this.b))},W)}))}}n.SimpleWorkerServer=m;function s(l){return new m(l,null)}n.create=s}),Y(X[52],Q([0,1,7,10]),function(O,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new E.Emitter,this.onDidChange=this.c.event,this.d=null}fire(N){this.c.fire({changedLanguages:N,changedColorMap:!1})}register(N,u){return this.a.set(N,u),this.fire([N]),(0,D.toDisposable)(()=>{this.a.get(N)===u&&(this.a.delete(N),this.fire([N]))})}registerFactory(N,u){var g;(g=this.b.get(N))===null||g===void 0||g.dispose();const S=new a(this,N,u);return this.b.set(N,S),(0,D.toDisposable)(()=>{const e=this.b.get(N);!e||e!==S||(this.b.delete(N),e.dispose())})}getOrCreate(N){return fe(this,void 0,void 0,function*(){const u=this.get(N);if(u)return u;const g=this.b.get(N);return!g||g.isResolved?null:(yield g.resolve(),this.get(N))})}get(N){return this.a.get(N)||null}isResolved(N){if(this.get(N))return!0;const g=this.b.get(N);return!!(!g||g.isResolved)}setColorMap(N){this.d=N,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}n.TokenizationRegistry=i;class a extends D.Disposable{get isResolved(){return this.c}constructor(N,u,g){super(),this.g=N,this.h=u,this.i=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return fe(this,void 0,void 0,function*(){return this.b||(this.b=this.j()),this.b})}j(){return fe(this,void 0,void 0,function*(){const N=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,N&&!this.a&&this.q(this.g.register(this.h,N))})}}}),Y(X[53],Q([0,1,30,12,2,52]),function(O,n,E,D,i,a){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class y{constructor(f,d,m){this.offset=f,this.type=d,this.language=m,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=y;class N{constructor(f,d){this.tokens=f,this.endState=d,this._tokenizationResultBrand=void 0}}n.TokenizationResult=N;class u{constructor(f,d){this.tokens=f,this.endState=d,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=u;var g;(function(b){const f=new Map;f.set(0,E.Codicon.symbolMethod),f.set(1,E.Codicon.symbolFunction),f.set(2,E.Codicon.symbolConstructor),f.set(3,E.Codicon.symbolField),f.set(4,E.Codicon.symbolVariable),f.set(5,E.Codicon.symbolClass),f.set(6,E.Codicon.symbolStruct),f.set(7,E.Codicon.symbolInterface),f.set(8,E.Codicon.symbolModule),f.set(9,E.Codicon.symbolProperty),f.set(10,E.Codicon.symbolEvent),f.set(11,E.Codicon.symbolOperator),f.set(12,E.Codicon.symbolUnit),f.set(13,E.Codicon.symbolValue),f.set(15,E.Codicon.symbolEnum),f.set(14,E.Codicon.symbolConstant),f.set(15,E.Codicon.symbolEnum),f.set(16,E.Codicon.symbolEnumMember),f.set(17,E.Codicon.symbolKeyword),f.set(27,E.Codicon.symbolSnippet),f.set(18,E.Codicon.symbolText),f.set(19,E.Codicon.symbolColor),f.set(20,E.Codicon.symbolFile),f.set(21,E.Codicon.symbolReference),f.set(22,E.Codicon.symbolCustomColor),f.set(23,E.Codicon.symbolFolder),f.set(24,E.Codicon.symbolTypeParameter),f.set(25,E.Codicon.account),f.set(26,E.Codicon.issues);function d(l){let r=f.get(l);return r||(console.info("No codicon found for CompletionItemKind "+l),r=E.Codicon.symbolProperty),r}b.toIcon=d;const m=new Map;m.set("method",0),m.set("function",1),m.set("constructor",2),m.set("field",3),m.set("variable",4),m.set("class",5),m.set("struct",6),m.set("interface",7),m.set("module",8),m.set("property",9),m.set("event",10),m.set("operator",11),m.set("unit",12),m.set("value",13),m.set("constant",14),m.set("enum",15),m.set("enum-member",16),m.set("enumMember",16),m.set("keyword",17),m.set("snippet",27),m.set("text",18),m.set("color",19),m.set("file",20),m.set("reference",21),m.set("customcolor",22),m.set("folder",23),m.set("type-parameter",24),m.set("typeParameter",24),m.set("account",25),m.set("issue",26);function s(l,r){let o=m.get(l);return typeof o>"u"&&!r&&(o=9),o}b.fromString=s})(g=n.CompletionItemKinds||(n.CompletionItemKinds={}));var S;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(S=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var e;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(e=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var w;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(w=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function h(b){return b&&D.URI.isUri(b.uri)&&i.Range.isIRange(b.range)&&(i.Range.isIRange(b.originSelectionRange)||i.Range.isIRange(b.targetSelectionRange))}n.isLocationLink=h;var C;(function(b){const f=new Map;f.set(0,E.Codicon.symbolFile),f.set(1,E.Codicon.symbolModule),f.set(2,E.Codicon.symbolNamespace),f.set(3,E.Codicon.symbolPackage),f.set(4,E.Codicon.symbolClass),f.set(5,E.Codicon.symbolMethod),f.set(6,E.Codicon.symbolProperty),f.set(7,E.Codicon.symbolField),f.set(8,E.Codicon.symbolConstructor),f.set(9,E.Codicon.symbolEnum),f.set(10,E.Codicon.symbolInterface),f.set(11,E.Codicon.symbolFunction),f.set(12,E.Codicon.symbolVariable),f.set(13,E.Codicon.symbolConstant),f.set(14,E.Codicon.symbolString),f.set(15,E.Codicon.symbolNumber),f.set(16,E.Codicon.symbolBoolean),f.set(17,E.Codicon.symbolArray),f.set(18,E.Codicon.symbolObject),f.set(19,E.Codicon.symbolKey),f.set(20,E.Codicon.symbolNull),f.set(21,E.Codicon.symbolEnumMember),f.set(22,E.Codicon.symbolStruct),f.set(23,E.Codicon.symbolEvent),f.set(24,E.Codicon.symbolOperator),f.set(25,E.Codicon.symbolTypeParameter);function d(m){let s=f.get(m);return s||(console.info("No codicon found for SymbolKind "+m),s=E.Codicon.symbolProperty),s}b.toIcon=d})(C=n.SymbolKinds||(n.SymbolKinds={}));class v{static fromValue(f){switch(f){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(f)}constructor(f){this.value=f}}v.Comment=new v("comment"),v.Imports=new v("imports"),v.Region=new v("region"),n.FoldingRangeKind=v;var p;(function(b){function f(d){return!d||typeof d!="object"?!1:typeof d.id=="string"&&typeof d.title=="string"}b.is=f})(p=n.Command||(n.Command={}));var _;(function(b){b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new a.TokenizationRegistry}),Y(X[54],Q([0,1,51,7,27,12,3,2,31,53,47]),function(O,n,E,D,i,a,y,N,u,g,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(C,v){return(0,i.KeyChord)(C,v)}}e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,n.KeyMod=e;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:D.Emitter,KeyCode:S.KeyCode,KeyMod:e,Position:y.Position,Range:N.Range,Selection:u.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:a.URI,Token:g.Token}}n.createMonacoBaseAPI=w}),Y(X[57],Q([0,1,16,12,3,2,44,20,40,41,54,22,46,39,11]),function(O,n,E,D,i,a,y,N,u,g,S,e,w,h,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class v extends y.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(f){return this.d[f-1]}getWordAtPosition(f,d){const m=(0,N.getWordAtText)(f.column,(0,N.ensureValidWordDefinition)(d),this.d[f.lineNumber-1],0);return m?new a.Range(f.lineNumber,m.startColumn,f.lineNumber,m.endColumn):null}words(f){const d=this.d,m=this.p.bind(this);let s=0,l="",r=0,o=[];return{*[Symbol.iterator](){for(;;)if(r<o.length){const c=l.substring(o[r].start,o[r].end);r+=1,yield c}else if(s<d.length)l=d[s],o=m(l,f),r=0,s+=1;else break}}}getLineWords(f,d){const m=this.d[f-1],s=this.p(m,d),l=[];for(const r of s)l.push({word:m.substring(r.start,r.end),startColumn:r.start+1,endColumn:r.end+1});return l}p(f,d){const m=[];let s;for(d.lastIndex=0;(s=d.exec(f))&&s[0].length!==0;)m.push({start:s.index,end:s.index+s[0].length});return m}getValueInRange(f){if(f=this.q(f),f.startLineNumber===f.endLineNumber)return this.d[f.startLineNumber-1].substring(f.startColumn-1,f.endColumn-1);const d=this.f,m=f.startLineNumber-1,s=f.endLineNumber-1,l=[];l.push(this.d[m].substring(f.startColumn-1));for(let r=m+1;r<s;r++)l.push(this.d[r]);return l.push(this.d[s].substring(0,f.endColumn-1)),l.join(d)}offsetAt(f){return f=this.r(f),this.k(),this.h.getPrefixSum(f.lineNumber-2)+(f.column-1)}positionAt(f){f=Math.floor(f),f=Math.max(0,f),this.k();const d=this.h.getIndexOf(f),m=this.d[d.index].length;return{lineNumber:1+d.index,column:1+Math.min(d.remainder,m)}}q(f){const d=this.r({lineNumber:f.startLineNumber,column:f.startColumn}),m=this.r({lineNumber:f.endLineNumber,column:f.endColumn});return d.lineNumber!==f.startLineNumber||d.column!==f.startColumn||m.lineNumber!==f.endLineNumber||m.column!==f.endColumn?{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:m.lineNumber,endColumn:m.column}:f}r(f){if(!i.Position.isIPosition(f))throw new Error("bad position");let{lineNumber:d,column:m}=f,s=!1;if(d<1)d=1,m=1,s=!0;else if(d>this.d.length)d=this.d.length,m=this.d[d-1].length+1,s=!0;else{const l=this.d[d-1].length+1;m<1?(m=1,s=!0):m>l&&(m=l,s=!0)}return s?{lineNumber:d,column:m}:f}}class p{constructor(f,d){this.c=f,this.d=Object.create(null),this.f=d,this.g=null}dispose(){this.d=Object.create(null)}h(f){return this.d[f]}j(){const f=[];return Object.keys(this.d).forEach(d=>f.push(this.d[d])),f}acceptNewModel(f){this.d[f.url]=new v(D.URI.parse(f.url),f.lines,f.EOL,f.versionId)}acceptModelChanged(f,d){if(!this.d[f])return;this.d[f].onEvents(d)}acceptRemovedModel(f){!this.d[f]||delete this.d[f]}computeUnicodeHighlights(f,d,m){return fe(this,void 0,void 0,function*(){const s=this.h(f);return s?w.UnicodeTextModelHighlighter.computeUnicodeHighlights(s,d,m):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(f,d,m,s){return fe(this,void 0,void 0,function*(){const l=this.h(f),r=this.h(d);return!l||!r?null:p.k(l,r,m,s)})}static k(f,d,m,s){const l=s==="experimental"?h.linesDiffComputers.experimental:h.linesDiffComputers.smart,r=f.getLinesContent(),o=d.getLinesContent(),c=l.computeDiff(r,o,m);return{identical:c.changes.length>0?!1:this.l(f,d),quitEarly:c.quitEarly,changes:c.changes.map(A=>{var R;return[A.originalRange.startLineNumber,A.originalRange.endLineNumberExclusive,A.modifiedRange.startLineNumber,A.modifiedRange.endLineNumberExclusive,(R=A.innerChanges)===null||R===void 0?void 0:R.map(M=>[M.originalRange.startLineNumber,M.originalRange.startColumn,M.originalRange.endLineNumber,M.originalRange.endColumn,M.modifiedRange.startLineNumber,M.modifiedRange.startColumn,M.modifiedRange.endLineNumber,M.modifiedRange.endColumn])]})}}static l(f,d){const m=f.getLineCount(),s=d.getLineCount();if(m!==s)return!1;for(let l=1;l<=m;l++){const r=f.getLineContent(l),o=d.getLineContent(l);if(r!==o)return!1}return!0}computeMoreMinimalEdits(f,d,m){return fe(this,void 0,void 0,function*(){const s=this.h(f);if(!s)return d;const l=[];let r;d=d.slice(0).sort((o,c)=>{if(o.range&&c.range)return a.Range.compareRangesUsingStarts(o.range,c.range);const L=o.range?0:1,A=c.range?0:1;return L-A});for(let{range:o,text:c,eol:L}of d){if(typeof L=="number"&&(r=L),a.Range.isEmpty(o)&&!c)continue;const A=s.getValueInRange(o);if(c=c.replace(/\r\n|\n|\r/g,s.eol),A===c)continue;if(Math.max(c.length,A.length)>p.n){l.push({range:o,text:c});continue}const R=(0,E.stringDiff)(A,c,m),M=s.offsetAt(a.Range.lift(o).getStartPosition());for(const T of R){const W=s.positionAt(M+T.originalStart),I=s.positionAt(M+T.originalStart+T.originalLength),q={text:c.substr(T.modifiedStart,T.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:I.lineNumber,endColumn:I.column}};s.getValueInRange(q.range)!==q.text&&l.push(q)}}return typeof r=="number"&&l.push({eol:r,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),l})}computeLinks(f){return fe(this,void 0,void 0,function*(){const d=this.h(f);return d?(0,u.computeLinks)(d):null})}textualSuggest(f,d,m,s){return fe(this,void 0,void 0,function*(){const l=new e.StopWatch(!0),r=new RegExp(m,s),o=new Set;e:for(const c of f){const L=this.h(c);if(!!L){for(const A of L.words(r))if(!(A===d||!isNaN(Number(A)))&&(o.add(A),o.size>p.o))break e}}return{words:Array.from(o),duration:l.elapsed()}})}computeWordRanges(f,d,m,s){return fe(this,void 0,void 0,function*(){const l=this.h(f);if(!l)return Object.create(null);const r=new RegExp(m,s),o=Object.create(null);for(let c=d.startLineNumber;c<d.endLineNumber;c++){const L=l.getLineWords(c,r);for(const A of L){if(!isNaN(Number(A.word)))continue;let R=o[A.word];R||(R=[],o[A.word]=R),R.push({startLineNumber:c,startColumn:A.startColumn,endLineNumber:c,endColumn:A.endColumn})}}return o})}navigateValueSet(f,d,m,s,l){return fe(this,void 0,void 0,function*(){const r=this.h(f);if(!r)return null;const o=new RegExp(s,l);d.startColumn===d.endColumn&&(d={startLineNumber:d.startLineNumber,startColumn:d.startColumn,endLineNumber:d.endLineNumber,endColumn:d.endColumn+1});const c=r.getValueInRange(d),L=r.getWordAtPosition({lineNumber:d.startLineNumber,column:d.startColumn},o);if(!L)return null;const A=r.getValueInRange(L);return g.BasicInplaceReplace.INSTANCE.navigateValueSet(d,c,L,A,m)})}loadForeignModule(f,d,m){const s=(o,c)=>this.c.fhr(o,c),r={host:(0,C.createProxyObject)(m,s),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(r,d),Promise.resolve((0,C.getAllMethodNames)(this.g))):new Promise((o,c)=>{O([f],L=>{this.g=L.create(r,d),o((0,C.getAllMethodNames)(this.g))},c)})}fmr(f,d){if(!this.g||typeof this.g[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.g[f].apply(this.g,d))}catch(m){return Promise.reject(m)}}}p.n=1e5,p.o=1e4,n.EditorSimpleWorker=p;function _(b){return new p(b,null)}n.create=_,typeof importScripts=="function"&&(globalThis.monaco=(0,S.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map